package de.upb.inferenceengine.engines;

import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.upb.javaast.methodast.IdentifierNode;
import de.upb.javaast.methodast.AllocationNode;
import de.uni_paderborn.fujaba.uml.ASTRootNode;

public class CreateMethodSubTypeEngine
extends GFRNEngine
{
   private  CreateMethodSubTypeEngine()
   {
   }

   private static CreateMethodSubTypeEngine theCreateMethodSubTypeEngine;

   public static CreateMethodSubTypeEngine get()
   {
      if (theCreateMethodSubTypeEngine == null)
      {
         theCreateMethodSubTypeEngine = new CreateMethodSubTypeEngine ();
      }
      return theCreateMethodSubTypeEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation createMethodSubType = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         createMethodSubType = this.annotateUsingMethodRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( createMethodSubType != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (createMethodSubType) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            createMethodSubType = this.annotateUsingTrigger_GeneralizationRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( createMethodSubType != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (createMethodSubType) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               createMethodSubType = this.annotateUsingCreatesRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            return (createMethodSubType) ;
         }
      }
   }


   private GFRNAnnotation annotateUsingCreatesRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterRootToAllocationNode6 = null ;
      ASTRootNode root = null ;
      de.upb.javaast.methodast.AllocationNode allocationNode6 = null ;
      boolean fujaba__Success = false ;
      CreateMethodSubTypeAnnotation createMethodSubType = null ;
      Iterator fujaba__IterGeneralization5ElementsResultType = null ;
      Iterator fujaba__IterMethodCreateAnnotationsCreateMethodSubType = null ;
      Iterator fujaba__IterResultTypeRevResultTypeMethodCreate = null ;
      Iterator fujaba__IterSubTypeAnnotationsGeneralization5 = null ;
      GeneralizationAnnotation generalization5 = null ;
      IdentifierNode constructor = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass resultType = null ;
      UMLClass subType = null ;
      UMLMethod methodCreate = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("creates", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            subType = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind generalization5: GeneralizationAnnotation
            fujaba__IterSubTypeAnnotationsGeneralization5 = subType.iteratorOfAnnotations () ;
            while ( fujaba__IterSubTypeAnnotationsGeneralization5.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSubTypeAnnotationsGeneralization5.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                  generalization5 = (GeneralizationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between generalization5 and subType
                  JavaSDM.ensure ( generalization5.hasInElements ("subClass", subType) ) ;
                   
                  // bind resultType: UMLClass
                  fujaba__IterGeneralization5ElementsResultType = generalization5.iteratorOfElements ("superClass") ;
                  while ( fujaba__IterGeneralization5ElementsResultType.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization5ElementsResultType.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        resultType = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(subType.equals (resultType)) ) ;
                         
                        // bind methodCreate: UMLMethod
                        fujaba__IterResultTypeRevResultTypeMethodCreate = resultType.iteratorOfRevResultType () ;
                        while ( fujaba__IterResultTypeRevResultTypeMethodCreate.hasNext () )
                        {
                           try
                           {
                              methodCreate = (UMLMethod) fujaba__IterResultTypeRevResultTypeMethodCreate.next () ;
                               
                              // bind root: ASTRootNode
                              root = methodCreate.getASTRootNode () ;
                              JavaSDM.ensure ( root != null ) ;
                               
                              // Path search between ASTRootNode and AllocationNode
                              // Bind allocationNode6 : AllocationNode
                              fujaba__IterRootToAllocationNode6 = new ASTPathVisitor (root, AllocationNode.class ) ;
                              while ( fujaba__IterRootToAllocationNode6.hasNext () )
                              {
                                 try
                                 {
                                    allocationNode6 = (de.upb.javaast.methodast.AllocationNode) fujaba__IterRootToAllocationNode6.next () ;
                                     
                                    // bind constructor: IdentifierNode
                                    constructor = allocationNode6.getIdentifier () ;
                                    JavaSDM.ensure ( constructor != null ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( constructor.getName().equals(subType.getName()) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object subType is really bound
                                          JavaSDM.ensure ( subType != null ) ;
                                           
                                          // check object methodCreate is really bound
                                          JavaSDM.ensure ( methodCreate != null ) ;
                                           
                                          // bind createMethodSubType: CreateMethodSubTypeAnnotation
                                          fujaba__IterMethodCreateAnnotationsCreateMethodSubType = methodCreate.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterMethodCreateAnnotationsCreateMethodSubType.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterMethodCreateAnnotationsCreateMethodSubType.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodSubTypeAnnotation ) ;
                                                createMethodSubType = (CreateMethodSubTypeAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between createMethodSubType and methodCreate
                                                JavaSDM.ensure ( createMethodSubType.hasInElements ("method", methodCreate) ) ;
                                                 
                                                // check To-Many-Link 'elements' between createMethodSubType and subType
                                                JavaSDM.ensure ( createMethodSubType.hasInElements ("creates", subType) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object subType is really bound
                                             JavaSDM.ensure ( subType != null ) ;
                                              
                                             // check object methodCreate is really bound
                                             JavaSDM.ensure ( methodCreate != null ) ;
                                              
                                             // check object resultType is really bound
                                             JavaSDM.ensure ( resultType != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(subType.equals (resultType)) ) ;
                                              
                                             // check object constructor is really bound
                                             JavaSDM.ensure ( constructor != null ) ;
                                              
                                             // check object root is really bound
                                             JavaSDM.ensure ( root != null ) ;
                                              
                                             // create object
                                             createMethodSubType = new CreateMethodSubTypeAnnotation ( ) ;
                                              
                                             // assign statement
                                             createMethodSubType.setClassification (0);
                                              
                                             // create link
                                             createMethodSubType.addToElements ("creates", subType);
                                              
                                             // create link
                                             createMethodSubType.addToElements ("method", methodCreate);
                                              
                                             // create link
                                             createMethodSubType.addToBoundObjects ("methodCreate", methodCreate);
                                              
                                             // create link
                                             createMethodSubType.addToBoundObjects ("resultType", resultType);
                                              
                                             // create link
                                             createMethodSubType.addToBoundObjects ("subType", subType);
                                              
                                             // create link
                                             createMethodSubType.addToBoundObjects ("constructor", constructor);
                                              
                                             // create link
                                             createMethodSubType.addToBoundObjects ("root", root);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object generalization5 is really bound
                                             JavaSDM.ensure ( generalization5 != null ) ;
                                              
                                             // check object createMethodSubType is really bound
                                             JavaSDM.ensure ( createMethodSubType != null ) ;
                                              
                                             // create link
                                             createMethodSubType.addToAntecedentAnnos (generalization5);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (createMethodSubType) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object createMethodSubType is really bound
            JavaSDM.ensure ( createMethodSubType != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("creates", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (createMethodSubType) ;
   }


   private GFRNAnnotation annotateUsingMethodRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterRootToAllocationNode2 = null ;
      ASTRootNode root = null ;
      de.upb.javaast.methodast.AllocationNode allocationNode2 = null ;
      boolean fujaba__Success = false ;
      CreateMethodSubTypeAnnotation createMethodSubType = null ;
      Iterator fujaba__IterGeneralization1ElementsSubType = null ;
      Iterator fujaba__IterMethodCreateAnnotationsCreateMethodSubType = null ;
      Iterator fujaba__IterResultTypeAnnotationsGeneralization1 = null ;
      GeneralizationAnnotation generalization1 = null ;
      IdentifierNode constructor = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass resultType = null ;
      UMLClass subType = null ;
      UMLMethod methodCreate = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            methodCreate = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind root: ASTRootNode
            root = methodCreate.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind resultType: UMLClass
            fujaba__TmpObject = methodCreate.getResultType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
            resultType = (UMLClass) fujaba__TmpObject ;
             
            // bind generalization1: GeneralizationAnnotation
            fujaba__IterResultTypeAnnotationsGeneralization1 = resultType.iteratorOfAnnotations () ;
            while ( fujaba__IterResultTypeAnnotationsGeneralization1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterResultTypeAnnotationsGeneralization1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                  generalization1 = (GeneralizationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between generalization1 and resultType
                  JavaSDM.ensure ( generalization1.hasInElements ("superClass", resultType) ) ;
                   
                  // bind subType: UMLClass
                  fujaba__IterGeneralization1ElementsSubType = generalization1.iteratorOfElements ("subClass") ;
                  while ( fujaba__IterGeneralization1ElementsSubType.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization1ElementsSubType.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        subType = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(resultType.equals (subType)) ) ;
                         
                        // Path search between ASTRootNode and AllocationNode
                        // Bind allocationNode2 : AllocationNode
                        fujaba__IterRootToAllocationNode2 = new ASTPathVisitor (root, AllocationNode.class ) ;
                        while ( fujaba__IterRootToAllocationNode2.hasNext () )
                        {
                           try
                           {
                              allocationNode2 = (de.upb.javaast.methodast.AllocationNode) fujaba__IterRootToAllocationNode2.next () ;
                               
                              // bind constructor: IdentifierNode
                              constructor = allocationNode2.getIdentifier () ;
                              JavaSDM.ensure ( constructor != null ) ;
                               
                              // constraint
                              JavaSDM.ensure ( constructor.getName().equals(subType.getName()) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object subType is really bound
                                    JavaSDM.ensure ( subType != null ) ;
                                     
                                    // check object methodCreate is really bound
                                    JavaSDM.ensure ( methodCreate != null ) ;
                                     
                                    // bind createMethodSubType: CreateMethodSubTypeAnnotation
                                    fujaba__IterMethodCreateAnnotationsCreateMethodSubType = methodCreate.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterMethodCreateAnnotationsCreateMethodSubType.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterMethodCreateAnnotationsCreateMethodSubType.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodSubTypeAnnotation ) ;
                                          createMethodSubType = (CreateMethodSubTypeAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between createMethodSubType and methodCreate
                                          JavaSDM.ensure ( createMethodSubType.hasInElements ("method", methodCreate) ) ;
                                           
                                          // check To-Many-Link 'elements' between createMethodSubType and subType
                                          JavaSDM.ensure ( createMethodSubType.hasInElements ("creates", subType) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object subType is really bound
                                       JavaSDM.ensure ( subType != null ) ;
                                        
                                       // check object methodCreate is really bound
                                       JavaSDM.ensure ( methodCreate != null ) ;
                                        
                                       // check object resultType is really bound
                                       JavaSDM.ensure ( resultType != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(subType.equals (resultType)) ) ;
                                        
                                       // check object constructor is really bound
                                       JavaSDM.ensure ( constructor != null ) ;
                                        
                                       // check object root is really bound
                                       JavaSDM.ensure ( root != null ) ;
                                        
                                       // create object
                                       createMethodSubType = new CreateMethodSubTypeAnnotation ( ) ;
                                        
                                       // assign statement
                                       createMethodSubType.setClassification (0);
                                        
                                       // create link
                                       createMethodSubType.addToElements ("creates", subType);
                                        
                                       // create link
                                       createMethodSubType.addToElements ("method", methodCreate);
                                        
                                       // create link
                                       createMethodSubType.addToBoundObjects ("methodCreate", methodCreate);
                                        
                                       // create link
                                       createMethodSubType.addToBoundObjects ("resultType", resultType);
                                        
                                       // create link
                                       createMethodSubType.addToBoundObjects ("subType", subType);
                                        
                                       // create link
                                       createMethodSubType.addToBoundObjects ("constructor", constructor);
                                        
                                       // create link
                                       createMethodSubType.addToBoundObjects ("root", root);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object generalization1 is really bound
                                       JavaSDM.ensure ( generalization1 != null ) ;
                                        
                                       // check object createMethodSubType is really bound
                                       JavaSDM.ensure ( createMethodSubType != null ) ;
                                        
                                       // create link
                                       createMethodSubType.addToAntecedentAnnos (generalization1);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (createMethodSubType) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object createMethodSubType is really bound
            JavaSDM.ensure ( createMethodSubType != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (createMethodSubType) ;
   }


   private GFRNAnnotation annotateUsingTrigger_GeneralizationRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterRootToAllocationNode4 = null ;
      ASTRootNode root = null ;
      de.upb.javaast.methodast.AllocationNode allocationNode4 = null ;
      boolean fujaba__Success = false ;
      CreateMethodSubTypeAnnotation createMethodSubType = null ;
      Iterator fujaba__IterGeneralization3ElementsResultType = null ;
      Iterator fujaba__IterGeneralization3ElementsSubType = null ;
      Iterator fujaba__IterResultTypeRevResultTypeMethodCreate = null ;
      Iterator fujaba__IterSubTypeAnnotationsCreateMethodSubType = null ;
      GeneralizationAnnotation generalization3 = null ;
      IdentifierNode constructor = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass resultType = null ;
      UMLClass subType = null ;
      UMLMethod methodCreate = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization3 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind resultType: UMLClass
            fujaba__IterGeneralization3ElementsResultType = generalization3.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization3ElementsResultType.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization3ElementsResultType.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  resultType = (UMLClass) fujaba__TmpObject ;
                   
                  // bind subType: UMLClass
                  fujaba__IterGeneralization3ElementsSubType = generalization3.iteratorOfElements ("subClass") ;
                  while ( fujaba__IterGeneralization3ElementsSubType.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization3ElementsSubType.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        subType = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(resultType.equals (subType)) ) ;
                         
                        // bind methodCreate: UMLMethod
                        fujaba__IterResultTypeRevResultTypeMethodCreate = resultType.iteratorOfRevResultType () ;
                        while ( fujaba__IterResultTypeRevResultTypeMethodCreate.hasNext () )
                        {
                           try
                           {
                              methodCreate = (UMLMethod) fujaba__IterResultTypeRevResultTypeMethodCreate.next () ;
                               
                              // bind root: ASTRootNode
                              root = methodCreate.getASTRootNode () ;
                              JavaSDM.ensure ( root != null ) ;
                               
                              // Path search between ASTRootNode and AllocationNode
                              // Bind allocationNode4 : AllocationNode
                              fujaba__IterRootToAllocationNode4 = new ASTPathVisitor (root, AllocationNode.class ) ;
                              while ( fujaba__IterRootToAllocationNode4.hasNext () )
                              {
                                 try
                                 {
                                    allocationNode4 = (de.upb.javaast.methodast.AllocationNode) fujaba__IterRootToAllocationNode4.next () ;
                                     
                                    // bind constructor: IdentifierNode
                                    constructor = allocationNode4.getIdentifier () ;
                                    JavaSDM.ensure ( constructor != null ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( constructor.getName().equals(subType.getName()) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object subType is really bound
                                          JavaSDM.ensure ( subType != null ) ;
                                           
                                          // check object methodCreate is really bound
                                          JavaSDM.ensure ( methodCreate != null ) ;
                                           
                                          // bind createMethodSubType: CreateMethodSubTypeAnnotation
                                          fujaba__IterSubTypeAnnotationsCreateMethodSubType = subType.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterSubTypeAnnotationsCreateMethodSubType.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterSubTypeAnnotationsCreateMethodSubType.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodSubTypeAnnotation ) ;
                                                createMethodSubType = (CreateMethodSubTypeAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between createMethodSubType and subType
                                                JavaSDM.ensure ( createMethodSubType.hasInElements ("creates", subType) ) ;
                                                 
                                                // check To-Many-Link 'elements' between createMethodSubType and methodCreate
                                                JavaSDM.ensure ( createMethodSubType.hasInElements ("method", methodCreate) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object subType is really bound
                                             JavaSDM.ensure ( subType != null ) ;
                                              
                                             // check object methodCreate is really bound
                                             JavaSDM.ensure ( methodCreate != null ) ;
                                              
                                             // check object resultType is really bound
                                             JavaSDM.ensure ( resultType != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(subType.equals (resultType)) ) ;
                                              
                                             // check object constructor is really bound
                                             JavaSDM.ensure ( constructor != null ) ;
                                              
                                             // check object root is really bound
                                             JavaSDM.ensure ( root != null ) ;
                                              
                                             // create object
                                             createMethodSubType = new CreateMethodSubTypeAnnotation ( ) ;
                                              
                                             // assign statement
                                             createMethodSubType.setClassification (0);
                                              
                                             // create link
                                             createMethodSubType.addToElements ("creates", subType);
                                              
                                             // create link
                                             createMethodSubType.addToElements ("method", methodCreate);
                                              
                                             // create link
                                             createMethodSubType.addToBoundObjects ("methodCreate", methodCreate);
                                              
                                             // create link
                                             createMethodSubType.addToBoundObjects ("resultType", resultType);
                                              
                                             // create link
                                             createMethodSubType.addToBoundObjects ("subType", subType);
                                              
                                             // create link
                                             createMethodSubType.addToBoundObjects ("constructor", constructor);
                                              
                                             // create link
                                             createMethodSubType.addToBoundObjects ("root", root);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object generalization3 is really bound
                                             JavaSDM.ensure ( generalization3 != null ) ;
                                              
                                             // check object createMethodSubType is really bound
                                             JavaSDM.ensure ( createMethodSubType != null ) ;
                                              
                                             // create link
                                             createMethodSubType.addToAntecedentAnnos (generalization3);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (createMethodSubType) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object createMethodSubType is really bound
            JavaSDM.ensure ( createMethodSubType != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_Generalization", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (createMethodSubType) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("creates", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass resultType = null ;
      UMLClass subType = null ;
      UMLMethod methodCreate = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Generalization") || annotation.equals ("MultiLevelGeneralization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            subType = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (subType);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            methodCreate = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind resultType: UMLClass
            fujaba__TmpObject = methodCreate.getResultType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
            resultType = (UMLClass) fujaba__TmpObject ;
             
            {
               //  for each flow
               set.add (resultType);
            } //  end for each flow
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
