package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;

public class MementoEngine
extends GFRNEngine
{
   private  MementoEngine()
   {
   }

   private static MementoEngine theMementoEngine;

   public static MementoEngine get()
   {
      if (theMementoEngine == null)
      {
         theMementoEngine = new MementoEngine ();
      }
      return theMementoEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation memento = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         memento = this.annotateUsingTrigger_SetMethodRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( memento != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (memento) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            memento = this.annotateUsingOriginatorRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (memento) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               memento = this.annotateUsingMementoRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( memento != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (memento) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  memento = this.annotateUsingTrigger_CreateMethodRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               try
               {
                  fujaba__Success = false ;
                   
                  // constraint
                  JavaSDM.ensure ( memento != null ) ;
                   
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               if ( fujaba__Success )
               {
                  return (memento) ;
               }
               else
               {
                  try
                  {
                     fujaba__Success = false ;
                      
                     // collabStatBegin 1 is empty !
                     memento = this.annotateUsingTrigger_MultiReferenceRole(asgElement);
                      
                     // collabStatEnd
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  try
                  {
                     fujaba__Success = false ;
                      
                     // constraint
                     JavaSDM.ensure ( memento != null ) ;
                      
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  if ( fujaba__Success )
                  {
                     return (memento) ;
                  }
                  else
                  {
                     try
                     {
                        fujaba__Success = false ;
                         
                        // collabStatBegin 1 is empty !
                        memento = this.annotateUsingCaretakerRole(asgElement);
                         
                        // collabStatEnd
                        fujaba__Success = true ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     return (memento) ;
                  }
               }
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingCaretakerRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod33 = null ;
      Iterator fujaba__IterCaretakerClassAttrsUMLAttr35 = null ;
      Iterator fujaba__IterCreateMethod33ElementsUMLMethod32 = null ;
      Iterator fujaba__IterFieldAnnotationsSetMethod31 = null ;
      Iterator fujaba__IterMementoClassAnnotationsCreateMethod33 = null ;
      Iterator fujaba__IterMementoClassAnnotationsMemento = null ;
      Iterator fujaba__IterMementoClassRevAttrTypeField = null ;
      Iterator fujaba__IterMultiReference34ElementsMementoClass = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod36 = null ;
      Iterator fujaba__IterUMLAttr35AnnotationsMultiReference34 = null ;
      MementoAnnotation memento = null ;
      MultiReferenceAnnotation multiReference34 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SetMethodAnnotation setMethod31 = null ;
      UMLAttr field = null ;
      UMLAttr uMLAttr35 = null ;
      UMLClass caretakerClass = null ;
      UMLClass mementoClass = null ;
      UMLClass originatorClass = null ;
      UMLMethod uMLMethod32 = null ;
      UMLMethod uMLMethod36 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("caretaker", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            caretakerClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr35: UMLAttr
            fujaba__IterCaretakerClassAttrsUMLAttr35 = caretakerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCaretakerClassAttrsUMLAttr35.hasNext () )
            {
               try
               {
                  uMLAttr35 = (UMLAttr) fujaba__IterCaretakerClassAttrsUMLAttr35.next () ;
                   
                  // bind multiReference34: MultiReferenceAnnotation
                  fujaba__IterUMLAttr35AnnotationsMultiReference34 = uMLAttr35.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr35AnnotationsMultiReference34.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLAttr35AnnotationsMultiReference34.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference34 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference34 and uMLAttr35
                        JavaSDM.ensure ( multiReference34.hasInElements ("field", uMLAttr35) ) ;
                         
                        // bind mementoClass: UMLClass
                        fujaba__IterMultiReference34ElementsMementoClass = multiReference34.iteratorOfElements ("references") ;
                        while ( fujaba__IterMultiReference34ElementsMementoClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMultiReference34ElementsMementoClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              mementoClass = (UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(caretakerClass.equals (mementoClass)) ) ;
                               
                              // bind createMethod33: CreateMethodAnnotation
                              fujaba__IterMementoClassAnnotationsCreateMethod33 = mementoClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterMementoClassAnnotationsCreateMethod33.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterMementoClassAnnotationsCreateMethod33.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                                    createMethod33 = (CreateMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between createMethod33 and mementoClass
                                    JavaSDM.ensure ( createMethod33.hasInElements ("creates", mementoClass) ) ;
                                     
                                    // bind field: UMLAttr
                                    fujaba__IterMementoClassRevAttrTypeField = mementoClass.iteratorOfRevAttrType () ;
                                    while ( fujaba__IterMementoClassRevAttrTypeField.hasNext () )
                                    {
                                       try
                                       {
                                          field = (UMLAttr) fujaba__IterMementoClassRevAttrTypeField.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLAttr35.equals (field)) ) ;
                                           
                                          // bind uMLMethod32: UMLMethod
                                          fujaba__IterCreateMethod33ElementsUMLMethod32 = createMethod33.iteratorOfElements ("method") ;
                                          while ( fujaba__IterCreateMethod33ElementsUMLMethod32.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterCreateMethod33ElementsUMLMethod32.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                uMLMethod32 = (UMLMethod) fujaba__TmpObject ;
                                                 
                                                // bind originatorClass: UMLClass
                                                originatorClass = uMLMethod32.getParent () ;
                                                JavaSDM.ensure ( originatorClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(mementoClass.equals (originatorClass)) ) ;
                                                 
                                                // bind setMethod31: SetMethodAnnotation
                                                fujaba__IterFieldAnnotationsSetMethod31 = field.iteratorOfAnnotations () ;
                                                while ( fujaba__IterFieldAnnotationsSetMethod31.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterFieldAnnotationsSetMethod31.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                                      setMethod31 = (SetMethodAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between setMethod31 and field
                                                      JavaSDM.ensure ( setMethod31.hasInElements ("field", field) ) ;
                                                       
                                                      // bind uMLMethod36: UMLMethod
                                                      fujaba__IterOriginatorClassMethodsUMLMethod36 = originatorClass.iteratorOfMethods () ;
                                                      while ( fujaba__IterOriginatorClassMethodsUMLMethod36.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            uMLMethod36 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod36.next () ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(uMLMethod32.equals (uMLMethod36)) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between setMethod31 and uMLMethod36
                                                            JavaSDM.ensure ( setMethod31.hasInElements ("method", uMLMethod36) ) ;
                                                             
                                                            {
                                                               //  for each flow
                                                               try
                                                               {
                                                                  fujaba__Success = false ;
                                                                   
                                                                  // check object originatorClass is really bound
                                                                  JavaSDM.ensure ( originatorClass != null ) ;
                                                                   
                                                                  // check object mementoClass is really bound
                                                                  JavaSDM.ensure ( mementoClass != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                                   
                                                                  // check object caretakerClass is really bound
                                                                  JavaSDM.ensure ( caretakerClass != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                                   
                                                                  // bind memento: MementoAnnotation
                                                                  fujaba__IterMementoClassAnnotationsMemento = mementoClass.iteratorOfAnnotations () ;
                                                                  while ( !(fujaba__Success) && fujaba__IterMementoClassAnnotationsMemento.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterMementoClassAnnotationsMemento.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof MementoAnnotation ) ;
                                                                        memento = (MementoAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between memento and mementoClass
                                                                        JavaSDM.ensure ( memento.hasInElements ("memento", mementoClass) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between memento and originatorClass
                                                                        JavaSDM.ensure ( memento.hasInElements ("originator", originatorClass) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between memento and caretakerClass
                                                                        JavaSDM.ensure ( memento.hasInElements ("caretaker", caretakerClass) ) ;
                                                                         
                                                                        fujaba__Success = true ;
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false ;
                                                               }
                                                                
                                                               if ( !(fujaba__Success) )
                                                               {
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object originatorClass is really bound
                                                                     JavaSDM.ensure ( originatorClass != null ) ;
                                                                      
                                                                     // check object mementoClass is really bound
                                                                     JavaSDM.ensure ( mementoClass != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                                      
                                                                     // check object caretakerClass is really bound
                                                                     JavaSDM.ensure ( caretakerClass != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                                      
                                                                     // check object field is really bound
                                                                     JavaSDM.ensure ( field != null ) ;
                                                                      
                                                                     // create object
                                                                     memento = new MementoAnnotation ( ) ;
                                                                      
                                                                     // assign statement
                                                                     memento.setClassification (1);
                                                                      
                                                                     // create link
                                                                     memento.addToElements ("originator", originatorClass);
                                                                      
                                                                     // create link
                                                                     memento.addToElements ("memento", mementoClass);
                                                                      
                                                                     // create link
                                                                     memento.addToElements ("caretaker", caretakerClass);
                                                                      
                                                                     // create link
                                                                     memento.addToBoundObjects ("originatorClass", originatorClass);
                                                                      
                                                                     // create link
                                                                     memento.addToBoundObjects ("mementoClass", mementoClass);
                                                                      
                                                                     // create link
                                                                     memento.addToBoundObjects ("caretakerClass", caretakerClass);
                                                                      
                                                                     // create link
                                                                     memento.addToBoundObjects ("field", field);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object setMethod31 is really bound
                                                                     JavaSDM.ensure ( setMethod31 != null ) ;
                                                                      
                                                                     // check object createMethod33 is really bound
                                                                     JavaSDM.ensure ( createMethod33 != null ) ;
                                                                      
                                                                     // check object multiReference34 is really bound
                                                                     JavaSDM.ensure ( multiReference34 != null ) ;
                                                                      
                                                                     // check object memento is really bound
                                                                     JavaSDM.ensure ( memento != null ) ;
                                                                      
                                                                     // create link
                                                                     memento.addToAntecedentAnnos (setMethod31);
                                                                      
                                                                     // create link
                                                                     memento.addToAntecedentAnnos (createMethod33);
                                                                      
                                                                     // create link
                                                                     memento.addToAntecedentAnnos (multiReference34);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  return (memento) ;
                                                               }
                                                            } //  end for each flow
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object memento is really bound
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("caretaker", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (memento) ;
   }


   private GFRNAnnotation annotateUsingMementoRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod15 = null ;
      Iterator fujaba__IterCaretakerClassAnnotationsMemento = null ;
      Iterator fujaba__IterCreateMethod15ElementsUMLMethod14 = null ;
      Iterator fujaba__IterFieldAnnotationsSetMethod13 = null ;
      Iterator fujaba__IterMementoClassAnnotationsCreateMethod15 = null ;
      Iterator fujaba__IterMementoClassAnnotationsMultiReference16 = null ;
      Iterator fujaba__IterMementoClassRevAttrTypeField = null ;
      Iterator fujaba__IterMultiReference16ElementsUMLAttr17 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod18 = null ;
      MementoAnnotation memento = null ;
      MultiReferenceAnnotation multiReference16 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SetMethodAnnotation setMethod13 = null ;
      UMLAttr field = null ;
      UMLAttr uMLAttr17 = null ;
      UMLClass caretakerClass = null ;
      UMLClass mementoClass = null ;
      UMLClass originatorClass = null ;
      UMLMethod uMLMethod14 = null ;
      UMLMethod uMLMethod18 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("memento", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mementoClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind createMethod15: CreateMethodAnnotation
            fujaba__IterMementoClassAnnotationsCreateMethod15 = mementoClass.iteratorOfAnnotations () ;
            while ( fujaba__IterMementoClassAnnotationsCreateMethod15.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMementoClassAnnotationsCreateMethod15.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                  createMethod15 = (CreateMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between createMethod15 and mementoClass
                  JavaSDM.ensure ( createMethod15.hasInElements ("creates", mementoClass) ) ;
                   
                  // bind multiReference16: MultiReferenceAnnotation
                  fujaba__IterMementoClassAnnotationsMultiReference16 = mementoClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterMementoClassAnnotationsMultiReference16.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMementoClassAnnotationsMultiReference16.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference16 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference16 and mementoClass
                        JavaSDM.ensure ( multiReference16.hasInElements ("references", mementoClass) ) ;
                         
                        // bind field: UMLAttr
                        fujaba__IterMementoClassRevAttrTypeField = mementoClass.iteratorOfRevAttrType () ;
                        while ( fujaba__IterMementoClassRevAttrTypeField.hasNext () )
                        {
                           try
                           {
                              field = (UMLAttr) fujaba__IterMementoClassRevAttrTypeField.next () ;
                               
                              // bind uMLMethod14: UMLMethod
                              fujaba__IterCreateMethod15ElementsUMLMethod14 = createMethod15.iteratorOfElements ("method") ;
                              while ( fujaba__IterCreateMethod15ElementsUMLMethod14.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateMethod15ElementsUMLMethod14.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod14 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // bind originatorClass: UMLClass
                                    originatorClass = uMLMethod14.getParent () ;
                                    JavaSDM.ensure ( originatorClass != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(mementoClass.equals (originatorClass)) ) ;
                                     
                                    // bind uMLAttr17: UMLAttr
                                    fujaba__IterMultiReference16ElementsUMLAttr17 = multiReference16.iteratorOfElements ("field") ;
                                    while ( fujaba__IterMultiReference16ElementsUMLAttr17.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterMultiReference16ElementsUMLAttr17.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                          uMLAttr17 = (UMLAttr) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(field.equals (uMLAttr17)) ) ;
                                           
                                          // bind caretakerClass: UMLClass
                                          caretakerClass = uMLAttr17.getParent () ;
                                          JavaSDM.ensure ( caretakerClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                           
                                          // bind setMethod13: SetMethodAnnotation
                                          fujaba__IterFieldAnnotationsSetMethod13 = field.iteratorOfAnnotations () ;
                                          while ( fujaba__IterFieldAnnotationsSetMethod13.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterFieldAnnotationsSetMethod13.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                                setMethod13 = (SetMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between setMethod13 and field
                                                JavaSDM.ensure ( setMethod13.hasInElements ("field", field) ) ;
                                                 
                                                // bind uMLMethod18: UMLMethod
                                                fujaba__IterOriginatorClassMethodsUMLMethod18 = originatorClass.iteratorOfMethods () ;
                                                while ( fujaba__IterOriginatorClassMethodsUMLMethod18.hasNext () )
                                                {
                                                   try
                                                   {
                                                      uMLMethod18 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod18.next () ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod14.equals (uMLMethod18)) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between setMethod13 and uMLMethod18
                                                      JavaSDM.ensure ( setMethod13.hasInElements ("method", uMLMethod18) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object originatorClass is really bound
                                                            JavaSDM.ensure ( originatorClass != null ) ;
                                                             
                                                            // check object mementoClass is really bound
                                                            JavaSDM.ensure ( mementoClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                             
                                                            // check object caretakerClass is really bound
                                                            JavaSDM.ensure ( caretakerClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                             
                                                            // bind memento: MementoAnnotation
                                                            fujaba__IterCaretakerClassAnnotationsMemento = caretakerClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterCaretakerClassAnnotationsMemento.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterCaretakerClassAnnotationsMemento.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof MementoAnnotation ) ;
                                                                  memento = (MementoAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between memento and caretakerClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("caretaker", caretakerClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between memento and originatorClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("originator", originatorClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between memento and mementoClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("memento", mementoClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object originatorClass is really bound
                                                               JavaSDM.ensure ( originatorClass != null ) ;
                                                                
                                                               // check object mementoClass is really bound
                                                               JavaSDM.ensure ( mementoClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                                
                                                               // check object caretakerClass is really bound
                                                               JavaSDM.ensure ( caretakerClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                                
                                                               // check object field is really bound
                                                               JavaSDM.ensure ( field != null ) ;
                                                                
                                                               // create object
                                                               memento = new MementoAnnotation ( ) ;
                                                                
                                                               // assign statement
                                                               memento.setClassification (1);
                                                                
                                                               // create link
                                                               memento.addToElements ("originator", originatorClass);
                                                                
                                                               // create link
                                                               memento.addToElements ("memento", mementoClass);
                                                                
                                                               // create link
                                                               memento.addToElements ("caretaker", caretakerClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("originatorClass", originatorClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("mementoClass", mementoClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("caretakerClass", caretakerClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("field", field);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object setMethod13 is really bound
                                                               JavaSDM.ensure ( setMethod13 != null ) ;
                                                                
                                                               // check object createMethod15 is really bound
                                                               JavaSDM.ensure ( createMethod15 != null ) ;
                                                                
                                                               // check object multiReference16 is really bound
                                                               JavaSDM.ensure ( multiReference16 != null ) ;
                                                                
                                                               // check object memento is really bound
                                                               JavaSDM.ensure ( memento != null ) ;
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (setMethod13);
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (createMethod15);
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (multiReference16);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (memento) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object memento is really bound
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("memento", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (memento) ;
   }


   private GFRNAnnotation annotateUsingOriginatorRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod9 = null ;
      Iterator fujaba__IterCreateMethod9ElementsMementoClass = null ;
      Iterator fujaba__IterMementoClassAnnotationsMultiReference10 = null ;
      Iterator fujaba__IterMultiReference10ElementsUMLAttr11 = null ;
      Iterator fujaba__IterOriginatorClassAnnotationsMemento = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod12 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod8 = null ;
      Iterator fujaba__IterSetMethod7ElementsField = null ;
      Iterator fujaba__IterUMLMethod12AnnotationsSetMethod7 = null ;
      Iterator fujaba__IterUMLMethod8AnnotationsCreateMethod9 = null ;
      MementoAnnotation memento = null ;
      MultiReferenceAnnotation multiReference10 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SetMethodAnnotation setMethod7 = null ;
      UMLAttr field = null ;
      UMLAttr uMLAttr11 = null ;
      UMLClass caretakerClass = null ;
      UMLClass mementoClass = null ;
      UMLClass originatorClass = null ;
      UMLMethod uMLMethod12 = null ;
      UMLMethod uMLMethod8 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("originator", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            originatorClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod8: UMLMethod
            fujaba__IterOriginatorClassMethodsUMLMethod8 = originatorClass.iteratorOfMethods () ;
            while ( fujaba__IterOriginatorClassMethodsUMLMethod8.hasNext () )
            {
               try
               {
                  uMLMethod8 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod8.next () ;
                   
                  // bind uMLMethod12: UMLMethod
                  fujaba__IterOriginatorClassMethodsUMLMethod12 = originatorClass.iteratorOfMethods () ;
                  while ( fujaba__IterOriginatorClassMethodsUMLMethod12.hasNext () )
                  {
                     try
                     {
                        uMLMethod12 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod12.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod8.equals (uMLMethod12)) ) ;
                         
                        // bind createMethod9: CreateMethodAnnotation
                        fujaba__IterUMLMethod8AnnotationsCreateMethod9 = uMLMethod8.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod8AnnotationsCreateMethod9.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod8AnnotationsCreateMethod9.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod9 = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod9 and uMLMethod8
                              JavaSDM.ensure ( createMethod9.hasInElements ("method", uMLMethod8) ) ;
                               
                              // bind setMethod7: SetMethodAnnotation
                              fujaba__IterUMLMethod12AnnotationsSetMethod7 = uMLMethod12.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod12AnnotationsSetMethod7.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod12AnnotationsSetMethod7.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                    setMethod7 = (SetMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between setMethod7 and uMLMethod12
                                    JavaSDM.ensure ( setMethod7.hasInElements ("method", uMLMethod12) ) ;
                                     
                                    // bind mementoClass: UMLClass
                                    fujaba__IterCreateMethod9ElementsMementoClass = createMethod9.iteratorOfElements ("creates") ;
                                    while ( fujaba__IterCreateMethod9ElementsMementoClass.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterCreateMethod9ElementsMementoClass.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          mementoClass = (UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                           
                                          // bind field: UMLAttr
                                          fujaba__IterSetMethod7ElementsField = setMethod7.iteratorOfElements ("field") ;
                                          while ( fujaba__IterSetMethod7ElementsField.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterSetMethod7ElementsField.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                                field = (UMLAttr) fujaba__TmpObject ;
                                                 
                                                // check To-One-Link 'attrType' between field and mementoClass
                                                JavaSDM.ensure ( (field.getAttrType () != null) && field.getAttrType ().equals (mementoClass) ) ;
                                                 
                                                // bind multiReference10: MultiReferenceAnnotation
                                                fujaba__IterMementoClassAnnotationsMultiReference10 = mementoClass.iteratorOfAnnotations () ;
                                                while ( fujaba__IterMementoClassAnnotationsMultiReference10.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterMementoClassAnnotationsMultiReference10.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                                      multiReference10 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between multiReference10 and mementoClass
                                                      JavaSDM.ensure ( multiReference10.hasInElements ("references", mementoClass) ) ;
                                                       
                                                      // bind uMLAttr11: UMLAttr
                                                      fujaba__IterMultiReference10ElementsUMLAttr11 = multiReference10.iteratorOfElements ("field") ;
                                                      while ( fujaba__IterMultiReference10ElementsUMLAttr11.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterMultiReference10ElementsUMLAttr11.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                                            uMLAttr11 = (UMLAttr) fujaba__TmpObject ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(field.equals (uMLAttr11)) ) ;
                                                             
                                                            // bind caretakerClass: UMLClass
                                                            caretakerClass = uMLAttr11.getParent () ;
                                                            JavaSDM.ensure ( caretakerClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                             
                                                            {
                                                               //  for each flow
                                                               try
                                                               {
                                                                  fujaba__Success = false ;
                                                                   
                                                                  // check object originatorClass is really bound
                                                                  JavaSDM.ensure ( originatorClass != null ) ;
                                                                   
                                                                  // check object mementoClass is really bound
                                                                  JavaSDM.ensure ( mementoClass != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                                   
                                                                  // check object caretakerClass is really bound
                                                                  JavaSDM.ensure ( caretakerClass != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                                   
                                                                  // bind memento: MementoAnnotation
                                                                  fujaba__IterOriginatorClassAnnotationsMemento = originatorClass.iteratorOfAnnotations () ;
                                                                  while ( !(fujaba__Success) && fujaba__IterOriginatorClassAnnotationsMemento.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterOriginatorClassAnnotationsMemento.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof MementoAnnotation ) ;
                                                                        memento = (MementoAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between memento and originatorClass
                                                                        JavaSDM.ensure ( memento.hasInElements ("originator", originatorClass) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between memento and mementoClass
                                                                        JavaSDM.ensure ( memento.hasInElements ("memento", mementoClass) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between memento and caretakerClass
                                                                        JavaSDM.ensure ( memento.hasInElements ("caretaker", caretakerClass) ) ;
                                                                         
                                                                        fujaba__Success = true ;
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false ;
                                                               }
                                                                
                                                               if ( !(fujaba__Success) )
                                                               {
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object originatorClass is really bound
                                                                     JavaSDM.ensure ( originatorClass != null ) ;
                                                                      
                                                                     // check object mementoClass is really bound
                                                                     JavaSDM.ensure ( mementoClass != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                                      
                                                                     // check object caretakerClass is really bound
                                                                     JavaSDM.ensure ( caretakerClass != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                                      
                                                                     // check object field is really bound
                                                                     JavaSDM.ensure ( field != null ) ;
                                                                      
                                                                     // create object
                                                                     memento = new MementoAnnotation ( ) ;
                                                                      
                                                                     // assign statement
                                                                     memento.setClassification (1);
                                                                      
                                                                     // create link
                                                                     memento.addToElements ("originator", originatorClass);
                                                                      
                                                                     // create link
                                                                     memento.addToElements ("memento", mementoClass);
                                                                      
                                                                     // create link
                                                                     memento.addToElements ("caretaker", caretakerClass);
                                                                      
                                                                     // create link
                                                                     memento.addToBoundObjects ("originatorClass", originatorClass);
                                                                      
                                                                     // create link
                                                                     memento.addToBoundObjects ("mementoClass", mementoClass);
                                                                      
                                                                     // create link
                                                                     memento.addToBoundObjects ("caretakerClass", caretakerClass);
                                                                      
                                                                     // create link
                                                                     memento.addToBoundObjects ("field", field);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object setMethod7 is really bound
                                                                     JavaSDM.ensure ( setMethod7 != null ) ;
                                                                      
                                                                     // check object createMethod9 is really bound
                                                                     JavaSDM.ensure ( createMethod9 != null ) ;
                                                                      
                                                                     // check object multiReference10 is really bound
                                                                     JavaSDM.ensure ( multiReference10 != null ) ;
                                                                      
                                                                     // check object memento is really bound
                                                                     JavaSDM.ensure ( memento != null ) ;
                                                                      
                                                                     // create link
                                                                     memento.addToAntecedentAnnos (setMethod7);
                                                                      
                                                                     // create link
                                                                     memento.addToAntecedentAnnos (createMethod9);
                                                                      
                                                                     // create link
                                                                     memento.addToAntecedentAnnos (multiReference10);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  return (memento) ;
                                                               }
                                                            } //  end for each flow
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object memento is really bound
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("originator", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (memento) ;
   }


   private GFRNAnnotation annotateUsingTrigger_CreateMethodRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod21 = null ;
      Iterator fujaba__IterCreateMethod21ElementsMementoClass = null ;
      Iterator fujaba__IterCreateMethod21ElementsUMLMethod20 = null ;
      Iterator fujaba__IterMementoClassAnnotationsMultiReference22 = null ;
      Iterator fujaba__IterMementoClassRevAttrTypeField = null ;
      Iterator fujaba__IterMultiReference22ElementsUMLAttr23 = null ;
      Iterator fujaba__IterOriginatorClassAnnotationsMemento = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod24 = null ;
      Iterator fujaba__IterUMLMethod24AnnotationsSetMethod19 = null ;
      MementoAnnotation memento = null ;
      MultiReferenceAnnotation multiReference22 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SetMethodAnnotation setMethod19 = null ;
      UMLAttr field = null ;
      UMLAttr uMLAttr23 = null ;
      UMLClass caretakerClass = null ;
      UMLClass mementoClass = null ;
      UMLClass originatorClass = null ;
      UMLMethod uMLMethod20 = null ;
      UMLMethod uMLMethod24 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_CreateMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof CreateMethodAnnotation ) ;
             
            // explicit type cast
            createMethod21 = (CreateMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod20: UMLMethod
            fujaba__IterCreateMethod21ElementsUMLMethod20 = createMethod21.iteratorOfElements ("method") ;
            while ( fujaba__IterCreateMethod21ElementsUMLMethod20.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterCreateMethod21ElementsUMLMethod20.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod20 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind originatorClass: UMLClass
                  originatorClass = uMLMethod20.getParent () ;
                  JavaSDM.ensure ( originatorClass != null ) ;
                   
                  // bind mementoClass: UMLClass
                  fujaba__IterCreateMethod21ElementsMementoClass = createMethod21.iteratorOfElements ("creates") ;
                  while ( fujaba__IterCreateMethod21ElementsMementoClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCreateMethod21ElementsMementoClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        mementoClass = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                         
                        // bind uMLMethod24: UMLMethod
                        fujaba__IterOriginatorClassMethodsUMLMethod24 = originatorClass.iteratorOfMethods () ;
                        while ( fujaba__IterOriginatorClassMethodsUMLMethod24.hasNext () )
                        {
                           try
                           {
                              uMLMethod24 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod24.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod20.equals (uMLMethod24)) ) ;
                               
                              // bind multiReference22: MultiReferenceAnnotation
                              fujaba__IterMementoClassAnnotationsMultiReference22 = mementoClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterMementoClassAnnotationsMultiReference22.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterMementoClassAnnotationsMultiReference22.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                    multiReference22 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiReference22 and mementoClass
                                    JavaSDM.ensure ( multiReference22.hasInElements ("references", mementoClass) ) ;
                                     
                                    // bind field: UMLAttr
                                    fujaba__IterMementoClassRevAttrTypeField = mementoClass.iteratorOfRevAttrType () ;
                                    while ( fujaba__IterMementoClassRevAttrTypeField.hasNext () )
                                    {
                                       try
                                       {
                                          field = (UMLAttr) fujaba__IterMementoClassRevAttrTypeField.next () ;
                                           
                                          // bind setMethod19: SetMethodAnnotation
                                          fujaba__IterUMLMethod24AnnotationsSetMethod19 = uMLMethod24.iteratorOfAnnotations () ;
                                          while ( fujaba__IterUMLMethod24AnnotationsSetMethod19.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLMethod24AnnotationsSetMethod19.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                                setMethod19 = (SetMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between setMethod19 and uMLMethod24
                                                JavaSDM.ensure ( setMethod19.hasInElements ("method", uMLMethod24) ) ;
                                                 
                                                // check To-Many-Link 'elements' between setMethod19 and field
                                                JavaSDM.ensure ( setMethod19.hasInElements ("field", field) ) ;
                                                 
                                                // bind uMLAttr23: UMLAttr
                                                fujaba__IterMultiReference22ElementsUMLAttr23 = multiReference22.iteratorOfElements ("field") ;
                                                while ( fujaba__IterMultiReference22ElementsUMLAttr23.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterMultiReference22ElementsUMLAttr23.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                                      uMLAttr23 = (UMLAttr) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(field.equals (uMLAttr23)) ) ;
                                                       
                                                      // bind caretakerClass: UMLClass
                                                      caretakerClass = uMLAttr23.getParent () ;
                                                      JavaSDM.ensure ( caretakerClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object originatorClass is really bound
                                                            JavaSDM.ensure ( originatorClass != null ) ;
                                                             
                                                            // check object mementoClass is really bound
                                                            JavaSDM.ensure ( mementoClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                             
                                                            // check object caretakerClass is really bound
                                                            JavaSDM.ensure ( caretakerClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                             
                                                            // bind memento: MementoAnnotation
                                                            fujaba__IterOriginatorClassAnnotationsMemento = originatorClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterOriginatorClassAnnotationsMemento.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterOriginatorClassAnnotationsMemento.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof MementoAnnotation ) ;
                                                                  memento = (MementoAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between memento and originatorClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("originator", originatorClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between memento and mementoClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("memento", mementoClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between memento and caretakerClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("caretaker", caretakerClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object originatorClass is really bound
                                                               JavaSDM.ensure ( originatorClass != null ) ;
                                                                
                                                               // check object mementoClass is really bound
                                                               JavaSDM.ensure ( mementoClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                                
                                                               // check object caretakerClass is really bound
                                                               JavaSDM.ensure ( caretakerClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                                
                                                               // check object field is really bound
                                                               JavaSDM.ensure ( field != null ) ;
                                                                
                                                               // create object
                                                               memento = new MementoAnnotation ( ) ;
                                                                
                                                               // assign statement
                                                               memento.setClassification (1);
                                                                
                                                               // create link
                                                               memento.addToElements ("originator", originatorClass);
                                                                
                                                               // create link
                                                               memento.addToElements ("memento", mementoClass);
                                                                
                                                               // create link
                                                               memento.addToElements ("caretaker", caretakerClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("originatorClass", originatorClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("mementoClass", mementoClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("caretakerClass", caretakerClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("field", field);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object setMethod19 is really bound
                                                               JavaSDM.ensure ( setMethod19 != null ) ;
                                                                
                                                               // check object createMethod21 is really bound
                                                               JavaSDM.ensure ( createMethod21 != null ) ;
                                                                
                                                               // check object multiReference22 is really bound
                                                               JavaSDM.ensure ( multiReference22 != null ) ;
                                                                
                                                               // check object memento is really bound
                                                               JavaSDM.ensure ( memento != null ) ;
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (setMethod19);
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (createMethod21);
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (multiReference22);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (memento) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object memento is really bound
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_CreateMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (memento) ;
   }


   private GFRNAnnotation annotateUsingTrigger_MultiReferenceRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod27 = null ;
      Iterator fujaba__IterCreateMethod27ElementsUMLMethod26 = null ;
      Iterator fujaba__IterFieldAnnotationsSetMethod25 = null ;
      Iterator fujaba__IterMementoClassAnnotationsCreateMethod27 = null ;
      Iterator fujaba__IterMementoClassRevAttrTypeField = null ;
      Iterator fujaba__IterMultiReference28ElementsMementoClass = null ;
      Iterator fujaba__IterMultiReference28ElementsUMLAttr29 = null ;
      Iterator fujaba__IterOriginatorClassAnnotationsMemento = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod30 = null ;
      MementoAnnotation memento = null ;
      MultiReferenceAnnotation multiReference28 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SetMethodAnnotation setMethod25 = null ;
      UMLAttr field = null ;
      UMLAttr uMLAttr29 = null ;
      UMLClass caretakerClass = null ;
      UMLClass mementoClass = null ;
      UMLClass originatorClass = null ;
      UMLMethod uMLMethod26 = null ;
      UMLMethod uMLMethod30 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_MultiReference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference28 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind mementoClass: UMLClass
            fujaba__IterMultiReference28ElementsMementoClass = multiReference28.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference28ElementsMementoClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference28ElementsMementoClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  mementoClass = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLAttr29: UMLAttr
                  fujaba__IterMultiReference28ElementsUMLAttr29 = multiReference28.iteratorOfElements ("field") ;
                  while ( fujaba__IterMultiReference28ElementsUMLAttr29.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMultiReference28ElementsUMLAttr29.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr29 = (UMLAttr) fujaba__TmpObject ;
                         
                        // bind caretakerClass: UMLClass
                        caretakerClass = uMLAttr29.getParent () ;
                        JavaSDM.ensure ( caretakerClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                         
                        // bind createMethod27: CreateMethodAnnotation
                        fujaba__IterMementoClassAnnotationsCreateMethod27 = mementoClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterMementoClassAnnotationsCreateMethod27.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMementoClassAnnotationsCreateMethod27.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod27 = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod27 and mementoClass
                              JavaSDM.ensure ( createMethod27.hasInElements ("creates", mementoClass) ) ;
                               
                              // bind field: UMLAttr
                              fujaba__IterMementoClassRevAttrTypeField = mementoClass.iteratorOfRevAttrType () ;
                              while ( fujaba__IterMementoClassRevAttrTypeField.hasNext () )
                              {
                                 try
                                 {
                                    field = (UMLAttr) fujaba__IterMementoClassRevAttrTypeField.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLAttr29.equals (field)) ) ;
                                     
                                    // bind uMLMethod26: UMLMethod
                                    fujaba__IterCreateMethod27ElementsUMLMethod26 = createMethod27.iteratorOfElements ("method") ;
                                    while ( fujaba__IterCreateMethod27ElementsUMLMethod26.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterCreateMethod27ElementsUMLMethod26.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          uMLMethod26 = (UMLMethod) fujaba__TmpObject ;
                                           
                                          // bind originatorClass: UMLClass
                                          originatorClass = uMLMethod26.getParent () ;
                                          JavaSDM.ensure ( originatorClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(mementoClass.equals (originatorClass)) ) ;
                                           
                                          // bind setMethod25: SetMethodAnnotation
                                          fujaba__IterFieldAnnotationsSetMethod25 = field.iteratorOfAnnotations () ;
                                          while ( fujaba__IterFieldAnnotationsSetMethod25.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterFieldAnnotationsSetMethod25.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                                setMethod25 = (SetMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between setMethod25 and field
                                                JavaSDM.ensure ( setMethod25.hasInElements ("field", field) ) ;
                                                 
                                                // bind uMLMethod30: UMLMethod
                                                fujaba__IterOriginatorClassMethodsUMLMethod30 = originatorClass.iteratorOfMethods () ;
                                                while ( fujaba__IterOriginatorClassMethodsUMLMethod30.hasNext () )
                                                {
                                                   try
                                                   {
                                                      uMLMethod30 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod30.next () ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod26.equals (uMLMethod30)) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between setMethod25 and uMLMethod30
                                                      JavaSDM.ensure ( setMethod25.hasInElements ("method", uMLMethod30) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object originatorClass is really bound
                                                            JavaSDM.ensure ( originatorClass != null ) ;
                                                             
                                                            // check object mementoClass is really bound
                                                            JavaSDM.ensure ( mementoClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                             
                                                            // check object caretakerClass is really bound
                                                            JavaSDM.ensure ( caretakerClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                             
                                                            // bind memento: MementoAnnotation
                                                            fujaba__IterOriginatorClassAnnotationsMemento = originatorClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterOriginatorClassAnnotationsMemento.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterOriginatorClassAnnotationsMemento.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof MementoAnnotation ) ;
                                                                  memento = (MementoAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between memento and originatorClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("originator", originatorClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between memento and mementoClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("memento", mementoClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between memento and caretakerClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("caretaker", caretakerClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object originatorClass is really bound
                                                               JavaSDM.ensure ( originatorClass != null ) ;
                                                                
                                                               // check object mementoClass is really bound
                                                               JavaSDM.ensure ( mementoClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                                
                                                               // check object caretakerClass is really bound
                                                               JavaSDM.ensure ( caretakerClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                                
                                                               // check object field is really bound
                                                               JavaSDM.ensure ( field != null ) ;
                                                                
                                                               // create object
                                                               memento = new MementoAnnotation ( ) ;
                                                                
                                                               // assign statement
                                                               memento.setClassification (1);
                                                                
                                                               // create link
                                                               memento.addToElements ("originator", originatorClass);
                                                                
                                                               // create link
                                                               memento.addToElements ("memento", mementoClass);
                                                                
                                                               // create link
                                                               memento.addToElements ("caretaker", caretakerClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("originatorClass", originatorClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("mementoClass", mementoClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("caretakerClass", caretakerClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("field", field);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object setMethod25 is really bound
                                                               JavaSDM.ensure ( setMethod25 != null ) ;
                                                                
                                                               // check object createMethod27 is really bound
                                                               JavaSDM.ensure ( createMethod27 != null ) ;
                                                                
                                                               // check object multiReference28 is really bound
                                                               JavaSDM.ensure ( multiReference28 != null ) ;
                                                                
                                                               // check object memento is really bound
                                                               JavaSDM.ensure ( memento != null ) ;
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (setMethod25);
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (createMethod27);
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (multiReference28);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (memento) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object memento is really bound
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_MultiReference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (memento) ;
   }


   private GFRNAnnotation annotateUsingTrigger_SetMethodRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod3 = null ;
      Iterator fujaba__IterCaretakerClassAnnotationsMemento = null ;
      Iterator fujaba__IterMementoClassAnnotationsCreateMethod3 = null ;
      Iterator fujaba__IterMementoClassAnnotationsMultiReference4 = null ;
      Iterator fujaba__IterMultiReference4ElementsUMLAttr5 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod2 = null ;
      Iterator fujaba__IterSetMethod1ElementsField = null ;
      Iterator fujaba__IterSetMethod1ElementsUMLMethod6 = null ;
      MementoAnnotation memento = null ;
      MultiReferenceAnnotation multiReference4 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SetMethodAnnotation setMethod1 = null ;
      UMLAttr field = null ;
      UMLAttr uMLAttr5 = null ;
      UMLClass caretakerClass = null ;
      UMLClass mementoClass = null ;
      UMLClass originatorClass = null ;
      UMLMethod uMLMethod2 = null ;
      UMLMethod uMLMethod6 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_SetMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof SetMethodAnnotation ) ;
             
            // explicit type cast
            setMethod1 = (SetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind field: UMLAttr
            fujaba__IterSetMethod1ElementsField = setMethod1.iteratorOfElements ("field") ;
            while ( fujaba__IterSetMethod1ElementsField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSetMethod1ElementsField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  field = (UMLAttr) fujaba__TmpObject ;
                   
                  // bind mementoClass: UMLClass
                  fujaba__TmpObject = field.getAttrType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  mementoClass = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLMethod6: UMLMethod
                  fujaba__IterSetMethod1ElementsUMLMethod6 = setMethod1.iteratorOfElements ("method") ;
                  while ( fujaba__IterSetMethod1ElementsUMLMethod6.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterSetMethod1ElementsUMLMethod6.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod6 = (UMLMethod) fujaba__TmpObject ;
                         
                        // bind originatorClass: UMLClass
                        originatorClass = uMLMethod6.getParent () ;
                        JavaSDM.ensure ( originatorClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(mementoClass.equals (originatorClass)) ) ;
                         
                        // bind createMethod3: CreateMethodAnnotation
                        fujaba__IterMementoClassAnnotationsCreateMethod3 = mementoClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterMementoClassAnnotationsCreateMethod3.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMementoClassAnnotationsCreateMethod3.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod3 = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod3 and mementoClass
                              JavaSDM.ensure ( createMethod3.hasInElements ("creates", mementoClass) ) ;
                               
                              // bind multiReference4: MultiReferenceAnnotation
                              fujaba__IterMementoClassAnnotationsMultiReference4 = mementoClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterMementoClassAnnotationsMultiReference4.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterMementoClassAnnotationsMultiReference4.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                    multiReference4 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiReference4 and mementoClass
                                    JavaSDM.ensure ( multiReference4.hasInElements ("references", mementoClass) ) ;
                                     
                                    // bind uMLMethod2: UMLMethod
                                    fujaba__IterOriginatorClassMethodsUMLMethod2 = originatorClass.iteratorOfMethods () ;
                                    while ( fujaba__IterOriginatorClassMethodsUMLMethod2.hasNext () )
                                    {
                                       try
                                       {
                                          uMLMethod2 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod2.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLMethod6.equals (uMLMethod2)) ) ;
                                           
                                          // check To-Many-Link 'elements' between createMethod3 and uMLMethod2
                                          JavaSDM.ensure ( createMethod3.hasInElements ("method", uMLMethod2) ) ;
                                           
                                          // bind uMLAttr5: UMLAttr
                                          fujaba__IterMultiReference4ElementsUMLAttr5 = multiReference4.iteratorOfElements ("field") ;
                                          while ( fujaba__IterMultiReference4ElementsUMLAttr5.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterMultiReference4ElementsUMLAttr5.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                                uMLAttr5 = (UMLAttr) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(field.equals (uMLAttr5)) ) ;
                                                 
                                                // bind caretakerClass: UMLClass
                                                caretakerClass = uMLAttr5.getParent () ;
                                                JavaSDM.ensure ( caretakerClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object originatorClass is really bound
                                                      JavaSDM.ensure ( originatorClass != null ) ;
                                                       
                                                      // check object mementoClass is really bound
                                                      JavaSDM.ensure ( mementoClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                       
                                                      // check object caretakerClass is really bound
                                                      JavaSDM.ensure ( caretakerClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                       
                                                      // bind memento: MementoAnnotation
                                                      fujaba__IterCaretakerClassAnnotationsMemento = caretakerClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterCaretakerClassAnnotationsMemento.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterCaretakerClassAnnotationsMemento.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof MementoAnnotation ) ;
                                                            memento = (MementoAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between memento and caretakerClass
                                                            JavaSDM.ensure ( memento.hasInElements ("caretaker", caretakerClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between memento and originatorClass
                                                            JavaSDM.ensure ( memento.hasInElements ("originator", originatorClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between memento and mementoClass
                                                            JavaSDM.ensure ( memento.hasInElements ("memento", mementoClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object originatorClass is really bound
                                                         JavaSDM.ensure ( originatorClass != null ) ;
                                                          
                                                         // check object mementoClass is really bound
                                                         JavaSDM.ensure ( mementoClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                          
                                                         // check object caretakerClass is really bound
                                                         JavaSDM.ensure ( caretakerClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                          
                                                         // check object field is really bound
                                                         JavaSDM.ensure ( field != null ) ;
                                                          
                                                         // create object
                                                         memento = new MementoAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         memento.setClassification (1);
                                                          
                                                         // create link
                                                         memento.addToElements ("originator", originatorClass);
                                                          
                                                         // create link
                                                         memento.addToElements ("memento", mementoClass);
                                                          
                                                         // create link
                                                         memento.addToElements ("caretaker", caretakerClass);
                                                          
                                                         // create link
                                                         memento.addToBoundObjects ("originatorClass", originatorClass);
                                                          
                                                         // create link
                                                         memento.addToBoundObjects ("mementoClass", mementoClass);
                                                          
                                                         // create link
                                                         memento.addToBoundObjects ("caretakerClass", caretakerClass);
                                                          
                                                         // create link
                                                         memento.addToBoundObjects ("field", field);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object setMethod1 is really bound
                                                         JavaSDM.ensure ( setMethod1 != null ) ;
                                                          
                                                         // check object createMethod3 is really bound
                                                         JavaSDM.ensure ( createMethod3 != null ) ;
                                                          
                                                         // check object multiReference4 is really bound
                                                         JavaSDM.ensure ( multiReference4 != null ) ;
                                                          
                                                         // check object memento is really bound
                                                         JavaSDM.ensure ( memento != null ) ;
                                                          
                                                         // create link
                                                         memento.addToAntecedentAnnos (setMethod1);
                                                          
                                                         // create link
                                                         memento.addToAntecedentAnnos (createMethod3);
                                                          
                                                         // create link
                                                         memento.addToAntecedentAnnos (multiReference4);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (memento) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object memento is really bound
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_SetMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (memento) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("originator", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("memento", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("caretaker", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof SetMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_SetMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof CreateMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_CreateMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof MultiReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_MultiReference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod38 = null ;
      CreateMethodAnnotation createMethod39 = null ;
      CreateMethodAnnotation createMethod44 = null ;
      CreateMethodAnnotation createMethod49 = null ;
      CreateMethodAnnotation createMethod58 = null ;
      CreateMethodAnnotation createMethod62 = null ;
      Iterator fujaba__IterCaretakerClassAttrsUMLAttr42 = null ;
      Iterator fujaba__IterCaretakerClassAttrsUMLAttr53 = null ;
      Iterator fujaba__IterCaretakerClassAttrsUMLAttr59 = null ;
      Iterator fujaba__IterCreateMethod38ElementsMementoClass = null ;
      Iterator fujaba__IterCreateMethod39ElementsUMLMethod40 = null ;
      Iterator fujaba__IterCreateMethod44ElementsUMLMethod45 = null ;
      Iterator fujaba__IterCreateMethod44ElementsUMLMethod47 = null ;
      Iterator fujaba__IterCreateMethod49ElementsUMLMethod50 = null ;
      Iterator fujaba__IterCreateMethod58ElementsMementoClass = null ;
      Iterator fujaba__IterCreateMethod62ElementsMementoClass = null ;
      Iterator fujaba__IterCreateMethod62ElementsUMLMethod63 = null ;
      Iterator fujaba__IterMementoClassAnnotationsCreateMethod39 = null ;
      Iterator fujaba__IterMementoClassAnnotationsCreateMethod44 = null ;
      Iterator fujaba__IterMementoClassAnnotationsCreateMethod49 = null ;
      Iterator fujaba__IterMementoClassRevAttrTypeField = null ;
      Iterator fujaba__IterMultiReference43ElementsMementoClass = null ;
      Iterator fujaba__IterMultiReference54ElementsMementoClass = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod37 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod41 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod46 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod48 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod51 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod52 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod56 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod57 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod61 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod64 = null ;
      Iterator fujaba__IterSetMethod31ElementsUMLMethod55 = null ;
      Iterator fujaba__IterSetMethod31ElementsUMLMethod60 = null ;
      Iterator fujaba__IterSetMethod65ElementsField = null ;
      Iterator fujaba__IterUMLAttr42AnnotationsMultiReference43 = null ;
      Iterator fujaba__IterUMLAttr53AnnotationsMultiReference54 = null ;
      Iterator fujaba__IterUMLMethod37AnnotationsCreateMethod38 = null ;
      Iterator fujaba__IterUMLMethod57AnnotationsCreateMethod58 = null ;
      Iterator fujaba__IterUMLMethod61AnnotationsCreateMethod62 = null ;
      Iterator fujaba__IterUMLMethod64AnnotationsSetMethod65 = null ;
      MultiReferenceAnnotation multiReference43 = null ;
      MultiReferenceAnnotation multiReference54 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SetMethodAnnotation setMethod31 = null ;
      SetMethodAnnotation setMethod65 = null ;
      UMLAttr field = null ;
      UMLAttr uMLAttr42 = null ;
      UMLAttr uMLAttr53 = null ;
      UMLAttr uMLAttr59 = null ;
      UMLClass caretakerClass = null ;
      UMLClass mementoClass = null ;
      UMLClass originatorClass = null ;
      UMLMethod uMLMethod37 = null ;
      UMLMethod uMLMethod40 = null ;
      UMLMethod uMLMethod41 = null ;
      UMLMethod uMLMethod45 = null ;
      UMLMethod uMLMethod46 = null ;
      UMLMethod uMLMethod47 = null ;
      UMLMethod uMLMethod48 = null ;
      UMLMethod uMLMethod50 = null ;
      UMLMethod uMLMethod51 = null ;
      UMLMethod uMLMethod52 = null ;
      UMLMethod uMLMethod55 = null ;
      UMLMethod uMLMethod56 = null ;
      UMLMethod uMLMethod57 = null ;
      UMLMethod uMLMethod60 = null ;
      UMLMethod uMLMethod61 = null ;
      UMLMethod uMLMethod63 = null ;
      UMLMethod uMLMethod64 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("SetMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            originatorClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod37: UMLMethod
            fujaba__IterOriginatorClassMethodsUMLMethod37 = originatorClass.iteratorOfMethods () ;
            while ( fujaba__IterOriginatorClassMethodsUMLMethod37.hasNext () )
            {
               try
               {
                  uMLMethod37 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod37.next () ;
                   
                  // bind createMethod38: CreateMethodAnnotation
                  fujaba__IterUMLMethod37AnnotationsCreateMethod38 = uMLMethod37.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod37AnnotationsCreateMethod38.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod37AnnotationsCreateMethod38.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                        createMethod38 = (CreateMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between createMethod38 and uMLMethod37
                        JavaSDM.ensure ( createMethod38.hasInElements ("method", uMLMethod37) ) ;
                         
                        // bind mementoClass: UMLClass
                        fujaba__IterCreateMethod38ElementsMementoClass = createMethod38.iteratorOfElements ("creates") ;
                        while ( fujaba__IterCreateMethod38ElementsMementoClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCreateMethod38ElementsMementoClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              mementoClass = (UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                               
                              // bind field: UMLAttr
                              fujaba__IterMementoClassRevAttrTypeField = mementoClass.iteratorOfRevAttrType () ;
                              while ( fujaba__IterMementoClassRevAttrTypeField.hasNext () )
                              {
                                 try
                                 {
                                    field = (UMLAttr) fujaba__IterMementoClassRevAttrTypeField.next () ;
                                     
                                    {
                                       //  for each flow
                                       set.add (field);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mementoClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind createMethod39: CreateMethodAnnotation
            fujaba__IterMementoClassAnnotationsCreateMethod39 = mementoClass.iteratorOfAnnotations () ;
            while ( fujaba__IterMementoClassAnnotationsCreateMethod39.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMementoClassAnnotationsCreateMethod39.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                  createMethod39 = (CreateMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between createMethod39 and mementoClass
                  JavaSDM.ensure ( createMethod39.hasInElements ("creates", mementoClass) ) ;
                   
                  // bind uMLMethod40: UMLMethod
                  fujaba__IterCreateMethod39ElementsUMLMethod40 = createMethod39.iteratorOfElements ("method") ;
                  while ( fujaba__IterCreateMethod39ElementsUMLMethod40.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCreateMethod39ElementsUMLMethod40.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod40 = (UMLMethod) fujaba__TmpObject ;
                         
                        // bind originatorClass: UMLClass
                        originatorClass = uMLMethod40.getParent () ;
                        JavaSDM.ensure ( originatorClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(mementoClass.equals (originatorClass)) ) ;
                         
                        // bind uMLMethod41: UMLMethod
                        fujaba__IterOriginatorClassMethodsUMLMethod41 = originatorClass.iteratorOfMethods () ;
                        while ( fujaba__IterOriginatorClassMethodsUMLMethod41.hasNext () )
                        {
                           try
                           {
                              uMLMethod41 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod41.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod40.equals (uMLMethod41)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (uMLMethod41);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            caretakerClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr42: UMLAttr
            fujaba__IterCaretakerClassAttrsUMLAttr42 = caretakerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCaretakerClassAttrsUMLAttr42.hasNext () )
            {
               try
               {
                  uMLAttr42 = (UMLAttr) fujaba__IterCaretakerClassAttrsUMLAttr42.next () ;
                   
                  // bind multiReference43: MultiReferenceAnnotation
                  fujaba__IterUMLAttr42AnnotationsMultiReference43 = uMLAttr42.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr42AnnotationsMultiReference43.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLAttr42AnnotationsMultiReference43.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference43 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference43 and uMLAttr42
                        JavaSDM.ensure ( multiReference43.hasInElements ("field", uMLAttr42) ) ;
                         
                        // bind mementoClass: UMLClass
                        fujaba__IterMultiReference43ElementsMementoClass = multiReference43.iteratorOfElements ("references") ;
                        while ( fujaba__IterMultiReference43ElementsMementoClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMultiReference43ElementsMementoClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              mementoClass = (UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(caretakerClass.equals (mementoClass)) ) ;
                               
                              // bind createMethod44: CreateMethodAnnotation
                              fujaba__IterMementoClassAnnotationsCreateMethod44 = mementoClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterMementoClassAnnotationsCreateMethod44.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterMementoClassAnnotationsCreateMethod44.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                                    createMethod44 = (CreateMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between createMethod44 and mementoClass
                                    JavaSDM.ensure ( createMethod44.hasInElements ("creates", mementoClass) ) ;
                                     
                                    // bind uMLMethod45: UMLMethod
                                    fujaba__IterCreateMethod44ElementsUMLMethod45 = createMethod44.iteratorOfElements ("method") ;
                                    while ( fujaba__IterCreateMethod44ElementsUMLMethod45.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterCreateMethod44ElementsUMLMethod45.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          uMLMethod45 = (UMLMethod) fujaba__TmpObject ;
                                           
                                          // bind originatorClass: UMLClass
                                          originatorClass = uMLMethod45.getParent () ;
                                          JavaSDM.ensure ( originatorClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caretakerClass.equals (originatorClass)) && !(mementoClass.equals (originatorClass)) ) ;
                                           
                                          // bind uMLMethod46: UMLMethod
                                          fujaba__IterOriginatorClassMethodsUMLMethod46 = originatorClass.iteratorOfMethods () ;
                                          while ( fujaba__IterOriginatorClassMethodsUMLMethod46.hasNext () )
                                          {
                                             try
                                             {
                                                uMLMethod46 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod46.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLMethod45.equals (uMLMethod46)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   set.add (uMLMethod46);
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof CreateMethodAnnotation ) ;
             
            // explicit type cast
            createMethod44 = (CreateMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod47: UMLMethod
            fujaba__IterCreateMethod44ElementsUMLMethod47 = createMethod44.iteratorOfElements ("method") ;
            while ( fujaba__IterCreateMethod44ElementsUMLMethod47.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterCreateMethod44ElementsUMLMethod47.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod47 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind originatorClass: UMLClass
                  originatorClass = uMLMethod47.getParent () ;
                  JavaSDM.ensure ( originatorClass != null ) ;
                   
                  // bind uMLMethod48: UMLMethod
                  fujaba__IterOriginatorClassMethodsUMLMethod48 = originatorClass.iteratorOfMethods () ;
                  while ( fujaba__IterOriginatorClassMethodsUMLMethod48.hasNext () )
                  {
                     try
                     {
                        uMLMethod48 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod48.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod47.equals (uMLMethod48)) ) ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod48);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference43 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind mementoClass: UMLClass
            fujaba__IterMultiReference43ElementsMementoClass = multiReference43.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference43ElementsMementoClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference43ElementsMementoClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  mementoClass = (UMLClass) fujaba__TmpObject ;
                   
                  // bind createMethod49: CreateMethodAnnotation
                  fujaba__IterMementoClassAnnotationsCreateMethod49 = mementoClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterMementoClassAnnotationsCreateMethod49.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMementoClassAnnotationsCreateMethod49.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                        createMethod49 = (CreateMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between createMethod49 and mementoClass
                        JavaSDM.ensure ( createMethod49.hasInElements ("creates", mementoClass) ) ;
                         
                        // bind uMLMethod50: UMLMethod
                        fujaba__IterCreateMethod49ElementsUMLMethod50 = createMethod49.iteratorOfElements ("method") ;
                        while ( fujaba__IterCreateMethod49ElementsUMLMethod50.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCreateMethod49ElementsUMLMethod50.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod50 = (UMLMethod) fujaba__TmpObject ;
                               
                              // bind originatorClass: UMLClass
                              originatorClass = uMLMethod50.getParent () ;
                              JavaSDM.ensure ( originatorClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(mementoClass.equals (originatorClass)) ) ;
                               
                              // bind uMLMethod51: UMLMethod
                              fujaba__IterOriginatorClassMethodsUMLMethod51 = originatorClass.iteratorOfMethods () ;
                              while ( fujaba__IterOriginatorClassMethodsUMLMethod51.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod51 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod51.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod50.equals (uMLMethod51)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (uMLMethod51);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("CreateMethod") || annotation.equals ("CreateMethodSubType") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            originatorClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod52: UMLMethod
            fujaba__IterOriginatorClassMethodsUMLMethod52 = originatorClass.iteratorOfMethods () ;
            while ( fujaba__IterOriginatorClassMethodsUMLMethod52.hasNext () )
            {
               try
               {
                  uMLMethod52 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod52.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod52);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mementoClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (mementoClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            caretakerClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr53: UMLAttr
            fujaba__IterCaretakerClassAttrsUMLAttr53 = caretakerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCaretakerClassAttrsUMLAttr53.hasNext () )
            {
               try
               {
                  uMLAttr53 = (UMLAttr) fujaba__IterCaretakerClassAttrsUMLAttr53.next () ;
                   
                  // bind multiReference54: MultiReferenceAnnotation
                  fujaba__IterUMLAttr53AnnotationsMultiReference54 = uMLAttr53.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr53AnnotationsMultiReference54.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLAttr53AnnotationsMultiReference54.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference54 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference54 and uMLAttr53
                        JavaSDM.ensure ( multiReference54.hasInElements ("field", uMLAttr53) ) ;
                         
                        // bind mementoClass: UMLClass
                        fujaba__IterMultiReference54ElementsMementoClass = multiReference54.iteratorOfElements ("references") ;
                        while ( fujaba__IterMultiReference54ElementsMementoClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMultiReference54ElementsMementoClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              mementoClass = (UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(caretakerClass.equals (mementoClass)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (mementoClass);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof SetMethodAnnotation ) ;
             
            // explicit type cast
            setMethod31 = (SetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod55: UMLMethod
            fujaba__IterSetMethod31ElementsUMLMethod55 = setMethod31.iteratorOfElements ("method") ;
            while ( fujaba__IterSetMethod31ElementsUMLMethod55.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSetMethod31ElementsUMLMethod55.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod55 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind originatorClass: UMLClass
                  originatorClass = uMLMethod55.getParent () ;
                  JavaSDM.ensure ( originatorClass != null ) ;
                   
                  // bind uMLMethod56: UMLMethod
                  fujaba__IterOriginatorClassMethodsUMLMethod56 = originatorClass.iteratorOfMethods () ;
                  while ( fujaba__IterOriginatorClassMethodsUMLMethod56.hasNext () )
                  {
                     try
                     {
                        uMLMethod56 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod56.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod55.equals (uMLMethod56)) ) ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod56);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference54 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind mementoClass: UMLClass
            fujaba__IterMultiReference54ElementsMementoClass = multiReference54.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference54ElementsMementoClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference54ElementsMementoClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  mementoClass = (UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (mementoClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("MultiReference") || annotation.equals ("ArrayReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            originatorClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod57: UMLMethod
            fujaba__IterOriginatorClassMethodsUMLMethod57 = originatorClass.iteratorOfMethods () ;
            while ( fujaba__IterOriginatorClassMethodsUMLMethod57.hasNext () )
            {
               try
               {
                  uMLMethod57 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod57.next () ;
                   
                  // bind createMethod58: CreateMethodAnnotation
                  fujaba__IterUMLMethod57AnnotationsCreateMethod58 = uMLMethod57.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod57AnnotationsCreateMethod58.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod57AnnotationsCreateMethod58.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                        createMethod58 = (CreateMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between createMethod58 and uMLMethod57
                        JavaSDM.ensure ( createMethod58.hasInElements ("method", uMLMethod57) ) ;
                         
                        // bind mementoClass: UMLClass
                        fujaba__IterCreateMethod58ElementsMementoClass = createMethod58.iteratorOfElements ("creates") ;
                        while ( fujaba__IterCreateMethod58ElementsMementoClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCreateMethod58ElementsMementoClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              mementoClass = (UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (mementoClass);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mementoClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (mementoClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            caretakerClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr59: UMLAttr
            fujaba__IterCaretakerClassAttrsUMLAttr59 = caretakerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCaretakerClassAttrsUMLAttr59.hasNext () )
            {
               try
               {
                  uMLAttr59 = (UMLAttr) fujaba__IterCaretakerClassAttrsUMLAttr59.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr59);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof SetMethodAnnotation ) ;
             
            // explicit type cast
            setMethod31 = (SetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod60: UMLMethod
            fujaba__IterSetMethod31ElementsUMLMethod60 = setMethod31.iteratorOfElements ("method") ;
            while ( fujaba__IterSetMethod31ElementsUMLMethod60.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSetMethod31ElementsUMLMethod60.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod60 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind originatorClass: UMLClass
                  originatorClass = uMLMethod60.getParent () ;
                  JavaSDM.ensure ( originatorClass != null ) ;
                   
                  // bind uMLMethod61: UMLMethod
                  fujaba__IterOriginatorClassMethodsUMLMethod61 = originatorClass.iteratorOfMethods () ;
                  while ( fujaba__IterOriginatorClassMethodsUMLMethod61.hasNext () )
                  {
                     try
                     {
                        uMLMethod61 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod61.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod60.equals (uMLMethod61)) ) ;
                         
                        // bind createMethod62: CreateMethodAnnotation
                        fujaba__IterUMLMethod61AnnotationsCreateMethod62 = uMLMethod61.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod61AnnotationsCreateMethod62.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod61AnnotationsCreateMethod62.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod62 = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod62 and uMLMethod61
                              JavaSDM.ensure ( createMethod62.hasInElements ("method", uMLMethod61) ) ;
                               
                              // bind mementoClass: UMLClass
                              fujaba__IterCreateMethod62ElementsMementoClass = createMethod62.iteratorOfElements ("creates") ;
                              while ( fujaba__IterCreateMethod62ElementsMementoClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateMethod62ElementsMementoClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    mementoClass = (UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (mementoClass);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof CreateMethodAnnotation ) ;
             
            // explicit type cast
            createMethod62 = (CreateMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod63: UMLMethod
            fujaba__IterCreateMethod62ElementsUMLMethod63 = createMethod62.iteratorOfElements ("method") ;
            while ( fujaba__IterCreateMethod62ElementsUMLMethod63.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterCreateMethod62ElementsUMLMethod63.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod63 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind originatorClass: UMLClass
                  originatorClass = uMLMethod63.getParent () ;
                  JavaSDM.ensure ( originatorClass != null ) ;
                   
                  // bind uMLMethod64: UMLMethod
                  fujaba__IterOriginatorClassMethodsUMLMethod64 = originatorClass.iteratorOfMethods () ;
                  while ( fujaba__IterOriginatorClassMethodsUMLMethod64.hasNext () )
                  {
                     try
                     {
                        uMLMethod64 = (UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod64.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod63.equals (uMLMethod64)) ) ;
                         
                        // bind setMethod65: SetMethodAnnotation
                        fujaba__IterUMLMethod64AnnotationsSetMethod65 = uMLMethod64.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod64AnnotationsSetMethod65.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod64AnnotationsSetMethod65.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                              setMethod65 = (SetMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between setMethod65 and uMLMethod64
                              JavaSDM.ensure ( setMethod65.hasInElements ("method", uMLMethod64) ) ;
                               
                              // bind field: UMLAttr
                              fujaba__IterSetMethod65ElementsField = setMethod65.iteratorOfElements ("field") ;
                              while ( fujaba__IterSetMethod65ElementsField.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterSetMethod65ElementsField.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                    field = (UMLAttr) fujaba__TmpObject ;
                                     
                                    // bind mementoClass: UMLClass
                                    fujaba__TmpObject = field.getAttrType () ;
                                    JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    mementoClass = (UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (mementoClass);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
