package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class SingleReferenceEngine
extends GFRNEngine
{
   private  SingleReferenceEngine()
   {
   }

   private static SingleReferenceEngine theSingleReferenceEngine;

   public static SingleReferenceEngine get()
   {
      if (theSingleReferenceEngine == null)
      {
         theSingleReferenceEngine = new SingleReferenceEngine ();
      }
      return theSingleReferenceEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation singleReference = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         singleReference = this.annotateUsingFieldRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( singleReference != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (singleReference) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            singleReference = this.annotateUsingReferencesRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         return (singleReference) ;
      }
   }


   private GFRNAnnotation annotateUsingFieldRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess2 = null ;
      Iterator fujaba__IterUMLAttr1AnnotationsContainerAccess2 = null ;
      Iterator fujaba__IterUMLClass3AnnotationsSingleReference = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SingleReferenceAnnotation singleReference = null ;
      UMLAttr uMLAttr1 = null ;
      UMLClass uMLClass3 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr1 = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass3: UMLClass
            fujaba__TmpObject = uMLAttr1.getAttrType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
            uMLClass3 = (UMLClass) fujaba__TmpObject ;
             
            // check To-Many-Link 'annotations' between uMLAttr1 and containerAccess2
            fujaba__IterUMLAttr1AnnotationsContainerAccess2 = uMLAttr1.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLAttr1AnnotationsContainerAccess2.hasNext () )
            {
               fujaba__TmpObject = fujaba__IterUMLAttr1AnnotationsContainerAccess2.next () ;
                
               if ( fujaba__TmpObject instanceof ContainerAccessAnnotation )
               {
                  containerAccess2 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  JavaSDM.ensure ( !(containerAccess2.hasInElements ("field", uMLAttr1)) ) ;
               }
            } // while
             
            {
               //  for each flow
               try
               {
                  fujaba__Success = false ;
                   
                  // check object uMLAttr1 is really bound
                  JavaSDM.ensure ( uMLAttr1 != null ) ;
                   
                  // check object uMLClass3 is really bound
                  JavaSDM.ensure ( uMLClass3 != null ) ;
                   
                  // bind singleReference: SingleReferenceAnnotation
                  fujaba__IterUMLClass3AnnotationsSingleReference = uMLClass3.iteratorOfAnnotations () ;
                  while ( !(fujaba__Success) && fujaba__IterUMLClass3AnnotationsSingleReference.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLClass3AnnotationsSingleReference.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                        singleReference = (SingleReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between singleReference and uMLClass3
                        JavaSDM.ensure ( singleReference.hasInElements ("references", uMLClass3) ) ;
                         
                        // check To-Many-Link 'elements' between singleReference and uMLAttr1
                        JavaSDM.ensure ( singleReference.hasInElements ("field", uMLAttr1) ) ;
                         
                        fujaba__Success = true ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               if ( !(fujaba__Success) )
               {
                  try
                  {
                     fujaba__Success = false ;
                      
                     // check object uMLAttr1 is really bound
                     JavaSDM.ensure ( uMLAttr1 != null ) ;
                      
                     // check object uMLClass3 is really bound
                     JavaSDM.ensure ( uMLClass3 != null ) ;
                      
                     // create object
                     singleReference = new SingleReferenceAnnotation ( ) ;
                      
                     // assign statement
                     singleReference.setClassification (0);
                      
                     // create link
                     singleReference.addToElements ("field", uMLAttr1);
                      
                     // create link
                     singleReference.addToElements ("references", uMLClass3);
                      
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  try
                  {
                     fujaba__Success = false ;
                      
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  return (singleReference) ;
               }
            } //  end for each flow
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object singleReference is really bound
            JavaSDM.ensure ( singleReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (singleReference) ;
   }


   private GFRNAnnotation annotateUsingReferencesRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess5 = null ;
      Iterator fujaba__IterUMLAttr4AnnotationsContainerAccess5 = null ;
      Iterator fujaba__IterUMLAttr4AnnotationsSingleReference = null ;
      Iterator fujaba__IterUMLClass6RevAttrTypeUMLAttr4 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SingleReferenceAnnotation singleReference = null ;
      UMLAttr uMLAttr4 = null ;
      UMLClass uMLClass6 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass6 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr4: UMLAttr
            fujaba__IterUMLClass6RevAttrTypeUMLAttr4 = uMLClass6.iteratorOfRevAttrType () ;
            while ( fujaba__IterUMLClass6RevAttrTypeUMLAttr4.hasNext () )
            {
               try
               {
                  uMLAttr4 = (UMLAttr) fujaba__IterUMLClass6RevAttrTypeUMLAttr4.next () ;
                   
                  // check To-Many-Link 'annotations' between uMLAttr4 and containerAccess5
                  fujaba__IterUMLAttr4AnnotationsContainerAccess5 = uMLAttr4.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr4AnnotationsContainerAccess5.hasNext () )
                  {
                     fujaba__TmpObject = fujaba__IterUMLAttr4AnnotationsContainerAccess5.next () ;
                      
                     if ( fujaba__TmpObject instanceof ContainerAccessAnnotation )
                     {
                        containerAccess5 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                         
                        JavaSDM.ensure ( !(containerAccess5.hasInElements ("field", uMLAttr4)) ) ;
                     }
                  } // while
                   
                  {
                     //  for each flow
                     try
                     {
                        fujaba__Success = false ;
                         
                        // check object uMLAttr4 is really bound
                        JavaSDM.ensure ( uMLAttr4 != null ) ;
                         
                        // check object uMLClass6 is really bound
                        JavaSDM.ensure ( uMLClass6 != null ) ;
                         
                        // bind singleReference: SingleReferenceAnnotation
                        fujaba__IterUMLAttr4AnnotationsSingleReference = uMLAttr4.iteratorOfAnnotations () ;
                        while ( !(fujaba__Success) && fujaba__IterUMLAttr4AnnotationsSingleReference.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLAttr4AnnotationsSingleReference.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                              singleReference = (SingleReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between singleReference and uMLAttr4
                              JavaSDM.ensure ( singleReference.hasInElements ("field", uMLAttr4) ) ;
                               
                              // check To-Many-Link 'elements' between singleReference and uMLClass6
                              JavaSDM.ensure ( singleReference.hasInElements ("references", uMLClass6) ) ;
                               
                              fujaba__Success = true ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     if ( !(fujaba__Success) )
                     {
                        try
                        {
                           fujaba__Success = false ;
                            
                           // check object uMLAttr4 is really bound
                           JavaSDM.ensure ( uMLAttr4 != null ) ;
                            
                           // check object uMLClass6 is really bound
                           JavaSDM.ensure ( uMLClass6 != null ) ;
                            
                           // create object
                           singleReference = new SingleReferenceAnnotation ( ) ;
                            
                           // assign statement
                           singleReference.setClassification (0);
                            
                           // create link
                           singleReference.addToElements ("field", uMLAttr4);
                            
                           // create link
                           singleReference.addToElements ("references", uMLClass6);
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        try
                        {
                           fujaba__Success = false ;
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        return (singleReference) ;
                     }
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object singleReference is really bound
            JavaSDM.ensure ( singleReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("references", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (singleReference) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ContainerAccessAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_ContainerAccess", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterUMLClass6RevAttrTypeUMLAttr7 = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr4 = null ;
      UMLAttr uMLAttr7 = null ;
      UMLClass uMLClass6 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("ContainerAccess") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr4 = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLAttr4);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass6 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr7: UMLAttr
            fujaba__IterUMLClass6RevAttrTypeUMLAttr7 = uMLClass6.iteratorOfRevAttrType () ;
            while ( fujaba__IterUMLClass6RevAttrTypeUMLAttr7.hasNext () )
            {
               try
               {
                  uMLAttr7 = (UMLAttr) fujaba__IterUMLClass6RevAttrTypeUMLAttr7.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr7);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr7 = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLAttr7);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
