package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.upb.javaast.methodast.MethodCallNode;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.upb.javaast.methodast.IdentifierNode;

public class TemplateMethodEngine
extends GFRNEngine
{
   private  TemplateMethodEngine()
   {
   }

   private static TemplateMethodEngine theTemplateMethodEngine;

   public static TemplateMethodEngine get()
   {
      if (theTemplateMethodEngine == null)
      {
         theTemplateMethodEngine = new TemplateMethodEngine ();
      }
      return theTemplateMethodEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation templateMethod = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         templateMethod = this.annotateUsingTemplateMethodRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( templateMethod != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (templateMethod) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            templateMethod = this.annotateUsingHookMethodRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         return (templateMethod) ;
      }
   }


   private GFRNAnnotation annotateUsingHookMethodRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterASTRootNode6ToMethodCallNode4 = null ;
      ASTRootNode aSTRootNode6 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterTemplateAnnotationsTemplateMethod = null ;
      Iterator fujaba__IterUMLClass5MethodsTemplate = null ;
      IdentifierNode id = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode4 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      TemplateMethodAnnotation templateMethod = null ;
      UMLClass uMLClass5 = null ;
      UMLMethod primitive = null ;
      UMLMethod template = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("hookMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            primitive = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (primitive.isAbstract () == true) ) ;
             
            // bind uMLClass5: UMLClass
            uMLClass5 = primitive.getParent () ;
            JavaSDM.ensure ( uMLClass5 != null ) ;
             
            // bind template: UMLMethod
            fujaba__IterUMLClass5MethodsTemplate = uMLClass5.iteratorOfMethods () ;
            while ( fujaba__IterUMLClass5MethodsTemplate.hasNext () )
            {
               try
               {
                  template = (UMLMethod) fujaba__IterUMLClass5MethodsTemplate.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (template.isAbstract () == false) ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(primitive.equals (template)) ) ;
                   
                  // bind aSTRootNode6: ASTRootNode
                  aSTRootNode6 = template.getASTRootNode () ;
                  JavaSDM.ensure ( aSTRootNode6 != null ) ;
                   
                  // Path search between ASTRootNode and MethodCallNode
                  // Bind methodCallNode4 : MethodCallNode
                  fujaba__IterASTRootNode6ToMethodCallNode4 = new ASTPathVisitor (aSTRootNode6, MethodCallNode.class ) ;
                  while ( fujaba__IterASTRootNode6ToMethodCallNode4.hasNext () )
                  {
                     try
                     {
                        methodCallNode4 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterASTRootNode6ToMethodCallNode4.next () ;
                         
                        // bind id: IdentifierNode
                        id = methodCallNode4.getIdentifier () ;
                        JavaSDM.ensure ( id != null ) ;
                         
                        // constraint
                        JavaSDM.ensure ( id.getName().equals(primitive.getName()) ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object template is really bound
                              JavaSDM.ensure ( template != null ) ;
                               
                              // check object primitive is really bound
                              JavaSDM.ensure ( primitive != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(template.equals (primitive)) ) ;
                               
                              // bind templateMethod: TemplateMethodAnnotation
                              fujaba__IterTemplateAnnotationsTemplateMethod = template.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterTemplateAnnotationsTemplateMethod.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterTemplateAnnotationsTemplateMethod.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof TemplateMethodAnnotation ) ;
                                    templateMethod = (TemplateMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between templateMethod and template
                                    JavaSDM.ensure ( templateMethod.hasInElements ("templateMethod", template) ) ;
                                     
                                    // check To-Many-Link 'elements' between templateMethod and primitive
                                    JavaSDM.ensure ( templateMethod.hasInElements ("hookMethod", primitive) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object template is really bound
                                 JavaSDM.ensure ( template != null ) ;
                                  
                                 // check object primitive is really bound
                                 JavaSDM.ensure ( primitive != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(template.equals (primitive)) ) ;
                                  
                                 // check object id is really bound
                                 JavaSDM.ensure ( id != null ) ;
                                  
                                 // create object
                                 templateMethod = new TemplateMethodAnnotation ( ) ;
                                  
                                 // assign statement
                                 templateMethod.setClassification (1);
                                  
                                 // create link
                                 templateMethod.addToElements ("templateMethod", template);
                                  
                                 // create link
                                 templateMethod.addToElements ("hookMethod", primitive);
                                  
                                 // create link
                                 templateMethod.addToBoundObjects ("template", template);
                                  
                                 // create link
                                 templateMethod.addToBoundObjects ("primitive", primitive);
                                  
                                 // create link
                                 templateMethod.addToBoundObjects ("id", id);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (templateMethod) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object templateMethod is really bound
            JavaSDM.ensure ( templateMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("hookMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (templateMethod) ;
   }


   private GFRNAnnotation annotateUsingTemplateMethodRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterASTRootNode3ToMethodCallNode1 = null ;
      ASTRootNode aSTRootNode3 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterPrimitiveAnnotationsTemplateMethod = null ;
      Iterator fujaba__IterUMLClass2MethodsPrimitive = null ;
      IdentifierNode id = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode1 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      TemplateMethodAnnotation templateMethod = null ;
      UMLClass uMLClass2 = null ;
      UMLMethod primitive = null ;
      UMLMethod template = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("templateMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            template = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (template.isAbstract () == false) ) ;
             
            // bind aSTRootNode3: ASTRootNode
            aSTRootNode3 = template.getASTRootNode () ;
            JavaSDM.ensure ( aSTRootNode3 != null ) ;
             
            // bind uMLClass2: UMLClass
            uMLClass2 = template.getParent () ;
            JavaSDM.ensure ( uMLClass2 != null ) ;
             
            // bind primitive: UMLMethod
            fujaba__IterUMLClass2MethodsPrimitive = uMLClass2.iteratorOfMethods () ;
            while ( fujaba__IterUMLClass2MethodsPrimitive.hasNext () )
            {
               try
               {
                  primitive = (UMLMethod) fujaba__IterUMLClass2MethodsPrimitive.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (primitive.isAbstract () == true) ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(template.equals (primitive)) ) ;
                   
                  // Path search between ASTRootNode and MethodCallNode
                  // Bind methodCallNode1 : MethodCallNode
                  fujaba__IterASTRootNode3ToMethodCallNode1 = new ASTPathVisitor (aSTRootNode3, MethodCallNode.class ) ;
                  while ( fujaba__IterASTRootNode3ToMethodCallNode1.hasNext () )
                  {
                     try
                     {
                        methodCallNode1 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterASTRootNode3ToMethodCallNode1.next () ;
                         
                        // bind id: IdentifierNode
                        id = methodCallNode1.getIdentifier () ;
                        JavaSDM.ensure ( id != null ) ;
                         
                        // constraint
                        JavaSDM.ensure ( id.getName().equals(primitive.getName()) ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object template is really bound
                              JavaSDM.ensure ( template != null ) ;
                               
                              // check object primitive is really bound
                              JavaSDM.ensure ( primitive != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(template.equals (primitive)) ) ;
                               
                              // bind templateMethod: TemplateMethodAnnotation
                              fujaba__IterPrimitiveAnnotationsTemplateMethod = primitive.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterPrimitiveAnnotationsTemplateMethod.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterPrimitiveAnnotationsTemplateMethod.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof TemplateMethodAnnotation ) ;
                                    templateMethod = (TemplateMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between templateMethod and primitive
                                    JavaSDM.ensure ( templateMethod.hasInElements ("hookMethod", primitive) ) ;
                                     
                                    // check To-Many-Link 'elements' between templateMethod and template
                                    JavaSDM.ensure ( templateMethod.hasInElements ("templateMethod", template) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object template is really bound
                                 JavaSDM.ensure ( template != null ) ;
                                  
                                 // check object primitive is really bound
                                 JavaSDM.ensure ( primitive != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(template.equals (primitive)) ) ;
                                  
                                 // check object id is really bound
                                 JavaSDM.ensure ( id != null ) ;
                                  
                                 // create object
                                 templateMethod = new TemplateMethodAnnotation ( ) ;
                                  
                                 // assign statement
                                 templateMethod.setClassification (1);
                                  
                                 // create link
                                 templateMethod.addToElements ("templateMethod", template);
                                  
                                 // create link
                                 templateMethod.addToElements ("hookMethod", primitive);
                                  
                                 // create link
                                 templateMethod.addToBoundObjects ("template", template);
                                  
                                 // create link
                                 templateMethod.addToBoundObjects ("primitive", primitive);
                                  
                                 // create link
                                 templateMethod.addToBoundObjects ("id", id);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (templateMethod) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object templateMethod is really bound
            JavaSDM.ensure ( templateMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("templateMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (templateMethod) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("templateMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("hookMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
