package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class ChainOfResponsibilityEngine
extends GFRNEngine
{
   private  ChainOfResponsibilityEngine()
   {
   }

   private static ChainOfResponsibilityEngine theChainOfResponsibilityEngine;

   public static ChainOfResponsibilityEngine get()
   {
      if (theChainOfResponsibilityEngine == null)
      {
         theChainOfResponsibilityEngine = new ChainOfResponsibilityEngine ();
      }
      return theChainOfResponsibilityEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation chainOfResponsibility = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         chainOfResponsibility = this.annotateUsingTrigger_DelegationRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( chainOfResponsibility != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (chainOfResponsibility) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            chainOfResponsibility = this.annotateUsingTrigger_DelegationRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( chainOfResponsibility != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (chainOfResponsibility) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               chainOfResponsibility = this.annotateUsingTrigger_GeneralizationRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( chainOfResponsibility != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (chainOfResponsibility) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  chainOfResponsibility = this.annotateUsingHandlerRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               try
               {
                  fujaba__Success = false ;
                   
                  // constraint
                  JavaSDM.ensure ( chainOfResponsibility != null ) ;
                   
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               if ( fujaba__Success )
               {
                  return (chainOfResponsibility) ;
               }
               else
               {
                  try
                  {
                     fujaba__Success = false ;
                      
                     // collabStatBegin 1 is empty !
                     chainOfResponsibility = this.annotateUsingTrigger_GeneralizationRole(asgElement);
                      
                     // collabStatEnd
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  try
                  {
                     fujaba__Success = false ;
                      
                     // constraint
                     JavaSDM.ensure ( chainOfResponsibility != null ) ;
                      
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  if ( fujaba__Success )
                  {
                     return (chainOfResponsibility) ;
                  }
                  else
                  {
                     try
                     {
                        fujaba__Success = false ;
                         
                        // collabStatBegin 1 is empty !
                        chainOfResponsibility = this.annotateUsingTrigger_OverridingMethodRole(asgElement);
                         
                        // collabStatEnd
                        fujaba__Success = true ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     try
                     {
                        fujaba__Success = false ;
                         
                        // constraint
                        JavaSDM.ensure ( chainOfResponsibility != null ) ;
                         
                        fujaba__Success = true ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     if ( fujaba__Success )
                     {
                        return (chainOfResponsibility) ;
                     }
                     else
                     {
                        try
                        {
                           fujaba__Success = false ;
                            
                           // collabStatBegin 1 is empty !
                           chainOfResponsibility = this.annotateUsingTrigger_OverridingMethodRole(asgElement);
                            
                           // collabStatEnd
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        try
                        {
                           fujaba__Success = false ;
                            
                           // constraint
                           JavaSDM.ensure ( chainOfResponsibility != null ) ;
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        if ( fujaba__Success )
                        {
                           return (chainOfResponsibility) ;
                        }
                        else
                        {
                           try
                           {
                              fujaba__Success = false ;
                               
                              // collabStatBegin 1 is empty !
                              chainOfResponsibility = this.annotateUsingTrigger_ReferenceRole(asgElement);
                               
                              // collabStatEnd
                              fujaba__Success = true ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           return (chainOfResponsibility) ;
                        }
                     }
                  }
               }
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingHandlerRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ChainOfResponsibilityAnnotation chainOfResponsibility = null ;
      DelegationAnnotation delegation22 = null ;
      DelegationAnnotation delegation23 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsDelegation22 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsDelegation23 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod26 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod27 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization24 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization25 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsReference28 = null ;
      Iterator fujaba__IterAbstractHandlerMethodsAbstractHandle = null ;
      Iterator fujaba__IterDelegation23ElementsConcreteHandle1 = null ;
      Iterator fujaba__IterGeneralization24ElementsConcreteHandler1 = null ;
      Iterator fujaba__IterGeneralization25ElementsConcreteHandler2 = null ;
      Iterator fujaba__IterOverridingMethod26ElementsConcreteHandle2 = null ;
      GeneralizationAnnotation generalization24 = null ;
      GeneralizationAnnotation generalization25 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod26 = null ;
      OverridingMethodAnnotation overridingMethod27 = null ;
      ReferenceAnnotation reference28 = null ;
      UMLClass abstractHandler = null ;
      UMLClass concreteHandler1 = null ;
      UMLClass concreteHandler2 = null ;
      UMLMethod abstractHandle = null ;
      UMLMethod concreteHandle1 = null ;
      UMLMethod concreteHandle2 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("handler", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
            while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
            {
               try
               {
                  abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  // bind generalization25: GeneralizationAnnotation
                  fujaba__IterAbstractHandlerAnnotationsGeneralization25 = abstractHandler.iteratorOfAnnotations () ;
                  while ( fujaba__IterAbstractHandlerAnnotationsGeneralization25.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization25.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization25 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization25 and abstractHandler
                        JavaSDM.ensure ( generalization25.hasInElements ("superClass", abstractHandler) ) ;
                         
                        // bind reference28: ReferenceAnnotation
                        fujaba__IterAbstractHandlerAnnotationsReference28 = abstractHandler.iteratorOfAnnotations () ;
                        while ( fujaba__IterAbstractHandlerAnnotationsReference28.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsReference28.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference28 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference28 and abstractHandler
                              JavaSDM.ensure ( reference28.hasInElements ("references", abstractHandler) ) ;
                               
                              // check To-Many-Link 'elements' between reference28 and abstractHandler
                              JavaSDM.ensure ( reference28.hasInElements ("referencingClass", abstractHandler) ) ;
                               
                              // bind generalization24: GeneralizationAnnotation
                              fujaba__IterAbstractHandlerAnnotationsGeneralization24 = abstractHandler.iteratorOfAnnotations () ;
                              while ( fujaba__IterAbstractHandlerAnnotationsGeneralization24.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization24.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization24 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization24 and abstractHandler
                                    JavaSDM.ensure ( generalization24.hasInElements ("superClass", abstractHandler) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(generalization25.equals (generalization24)) ) ;
                                     
                                    // bind overridingMethod26: OverridingMethodAnnotation
                                    fujaba__IterAbstractHandleAnnotationsOverridingMethod26 = abstractHandle.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod26.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod26.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                          overridingMethod26 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between overridingMethod26 and abstractHandle
                                          JavaSDM.ensure ( overridingMethod26.hasInElements ("overridden", abstractHandle) ) ;
                                           
                                          // bind delegation22: DelegationAnnotation
                                          fujaba__IterAbstractHandleAnnotationsDelegation22 = abstractHandle.iteratorOfAnnotations () ;
                                          while ( fujaba__IterAbstractHandleAnnotationsDelegation22.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsDelegation22.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                delegation22 = (DelegationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between delegation22 and abstractHandle
                                                JavaSDM.ensure ( delegation22.hasInElements ("callee", abstractHandle) ) ;
                                                 
                                                // bind delegation23: DelegationAnnotation
                                                fujaba__IterAbstractHandleAnnotationsDelegation23 = abstractHandle.iteratorOfAnnotations () ;
                                                while ( fujaba__IterAbstractHandleAnnotationsDelegation23.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsDelegation23.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                      delegation23 = (DelegationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between delegation23 and abstractHandle
                                                      JavaSDM.ensure ( delegation23.hasInElements ("callee", abstractHandle) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(delegation22.equals (delegation23)) ) ;
                                                       
                                                      // bind overridingMethod27: OverridingMethodAnnotation
                                                      fujaba__IterAbstractHandleAnnotationsOverridingMethod27 = abstractHandle.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod27.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod27.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                            overridingMethod27 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between overridingMethod27 and abstractHandle
                                                            JavaSDM.ensure ( overridingMethod27.hasInElements ("overridden", abstractHandle) ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(overridingMethod26.equals (overridingMethod27)) ) ;
                                                             
                                                            // bind concreteHandler2: UMLClass
                                                            fujaba__IterGeneralization25ElementsConcreteHandler2 = generalization25.iteratorOfElements ("subClass") ;
                                                            while ( fujaba__IterGeneralization25ElementsConcreteHandler2.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterGeneralization25ElementsConcreteHandler2.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                                  concreteHandler2 = (UMLClass) fujaba__TmpObject ;
                                                                   
                                                                  // attribute condition
                                                                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) ) ;
                                                                   
                                                                  // bind concreteHandler1: UMLClass
                                                                  fujaba__IterGeneralization24ElementsConcreteHandler1 = generalization24.iteratorOfElements ("subClass") ;
                                                                  while ( fujaba__IterGeneralization24ElementsConcreteHandler1.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterGeneralization24ElementsConcreteHandler1.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                                        concreteHandler1 = (UMLClass) fujaba__TmpObject ;
                                                                         
                                                                        // attribute condition
                                                                        JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) && !(concreteHandler2.equals (concreteHandler1)) ) ;
                                                                         
                                                                        // bind concreteHandle2: UMLMethod
                                                                        fujaba__IterOverridingMethod26ElementsConcreteHandle2 = overridingMethod26.iteratorOfElements ("overriding") ;
                                                                        while ( fujaba__IterOverridingMethod26ElementsConcreteHandle2.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterOverridingMethod26ElementsConcreteHandle2.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                              concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                                                                               
                                                                              // attribute condition
                                                                              JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle2)) ) ;
                                                                               
                                                                              // check To-One-Link 'parent' between concreteHandle2 and concreteHandler2
                                                                              JavaSDM.ensure ( (concreteHandle2.getParent () != null) && concreteHandle2.getParent ().equals (concreteHandler2) ) ;
                                                                               
                                                                              // check To-Many-Link 'elements' between delegation22 and concreteHandle2
                                                                              JavaSDM.ensure ( delegation22.hasInElements ("caller", concreteHandle2) ) ;
                                                                               
                                                                              // bind concreteHandle1: UMLMethod
                                                                              fujaba__IterDelegation23ElementsConcreteHandle1 = delegation23.iteratorOfElements ("caller") ;
                                                                              while ( fujaba__IterDelegation23ElementsConcreteHandle1.hasNext () )
                                                                              {
                                                                                 try
                                                                                 {
                                                                                    fujaba__TmpObject = fujaba__IterDelegation23ElementsConcreteHandle1.next () ;
                                                                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                                    concreteHandle1 = (UMLMethod) fujaba__TmpObject ;
                                                                                     
                                                                                    // attribute condition
                                                                                    JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(concreteHandle2.equals (concreteHandle1)) && !(abstractHandle.equals (concreteHandle1)) ) ;
                                                                                     
                                                                                    // check To-Many-Link 'elements' between overridingMethod27 and concreteHandle1
                                                                                    JavaSDM.ensure ( overridingMethod27.hasInElements ("overriding", concreteHandle1) ) ;
                                                                                     
                                                                                    // check To-One-Link 'parent' between concreteHandle1 and concreteHandler1
                                                                                    JavaSDM.ensure ( (concreteHandle1.getParent () != null) && concreteHandle1.getParent ().equals (concreteHandler1) ) ;
                                                                                     
                                                                                    {
                                                                                       //  for each flow
                                                                                       try
                                                                                       {
                                                                                          fujaba__Success = false ;
                                                                                           
                                                                                          // check object abstractHandler is really bound
                                                                                          JavaSDM.ensure ( abstractHandler != null ) ;
                                                                                           
                                                                                          // bind chainOfResponsibility: ChainOfResponsibilityAnnotation
                                                                                          fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = abstractHandler.iteratorOfAnnotations () ;
                                                                                          while ( !(fujaba__Success) && fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.hasNext () )
                                                                                          {
                                                                                             try
                                                                                             {
                                                                                                fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.next () ;
                                                                                                JavaSDM.ensure ( fujaba__TmpObject instanceof ChainOfResponsibilityAnnotation ) ;
                                                                                                chainOfResponsibility = (ChainOfResponsibilityAnnotation) fujaba__TmpObject ;
                                                                                                 
                                                                                                // check Reverse-Qualified-Link 'elements' between chainOfResponsibility and abstractHandler
                                                                                                JavaSDM.ensure ( chainOfResponsibility.hasInElements ("handler", abstractHandler) ) ;
                                                                                                 
                                                                                                fujaba__Success = true ;
                                                                                             }
                                                                                             catch ( JavaSDMException fujaba__InternalException )
                                                                                             {
                                                                                             }
                                                                                          }
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                          fujaba__Success = false ;
                                                                                       }
                                                                                        
                                                                                       if ( !(fujaba__Success) )
                                                                                       {
                                                                                          try
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                              
                                                                                             // check object abstractHandler is really bound
                                                                                             JavaSDM.ensure ( abstractHandler != null ) ;
                                                                                              
                                                                                             // check object concreteHandler2 is really bound
                                                                                             JavaSDM.ensure ( concreteHandler2 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) ) ;
                                                                                              
                                                                                             // check object concreteHandle2 is really bound
                                                                                             JavaSDM.ensure ( concreteHandle2 != null ) ;
                                                                                              
                                                                                             // check object abstractHandle is really bound
                                                                                             JavaSDM.ensure ( abstractHandle != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                                                                                              
                                                                                             // check object concreteHandle1 is really bound
                                                                                             JavaSDM.ensure ( concreteHandle1 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(concreteHandle2.equals (concreteHandle1)) && !(abstractHandle.equals (concreteHandle1)) ) ;
                                                                                              
                                                                                             // check object concreteHandler1 is really bound
                                                                                             JavaSDM.ensure ( concreteHandler1 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) && !(concreteHandler2.equals (concreteHandler1)) ) ;
                                                                                              
                                                                                             // create object
                                                                                             chainOfResponsibility = new ChainOfResponsibilityAnnotation ( ) ;
                                                                                              
                                                                                             // assign statement
                                                                                             chainOfResponsibility.setClassification (1);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToElements ("handler", abstractHandler);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("abstractHandler", abstractHandler);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandler2", concreteHandler2);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandle2", concreteHandle2);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("abstractHandle", abstractHandle);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandle1", concreteHandle1);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandler1", concreteHandler1);
                                                                                              
                                                                                             fujaba__Success = true ;
                                                                                          }
                                                                                          catch ( JavaSDMException fujaba__InternalException )
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                          }
                                                                                           
                                                                                          try
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                              
                                                                                             // check object delegation22 is really bound
                                                                                             JavaSDM.ensure ( delegation22 != null ) ;
                                                                                              
                                                                                             // check object delegation23 is really bound
                                                                                             JavaSDM.ensure ( delegation23 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(delegation22.equals (delegation23)) ) ;
                                                                                              
                                                                                             // check object generalization24 is really bound
                                                                                             JavaSDM.ensure ( generalization24 != null ) ;
                                                                                              
                                                                                             // check object generalization25 is really bound
                                                                                             JavaSDM.ensure ( generalization25 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(generalization24.equals (generalization25)) ) ;
                                                                                              
                                                                                             // check object overridingMethod26 is really bound
                                                                                             JavaSDM.ensure ( overridingMethod26 != null ) ;
                                                                                              
                                                                                             // check object overridingMethod27 is really bound
                                                                                             JavaSDM.ensure ( overridingMethod27 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(overridingMethod26.equals (overridingMethod27)) ) ;
                                                                                              
                                                                                             // check object reference28 is really bound
                                                                                             JavaSDM.ensure ( reference28 != null ) ;
                                                                                              
                                                                                             // check object chainOfResponsibility is really bound
                                                                                             JavaSDM.ensure ( chainOfResponsibility != null ) ;
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (delegation22);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (delegation23);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (generalization24);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (generalization25);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (overridingMethod26);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (overridingMethod27);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (reference28);
                                                                                              
                                                                                             fujaba__Success = true ;
                                                                                          }
                                                                                          catch ( JavaSDMException fujaba__InternalException )
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                          }
                                                                                           
                                                                                          return (chainOfResponsibility) ;
                                                                                       }
                                                                                    } //  end for each flow
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                 }
                                                                              }
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object chainOfResponsibility is really bound
            JavaSDM.ensure ( chainOfResponsibility != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("handler", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (chainOfResponsibility) ;
   }


   private GFRNAnnotation annotateUsingTrigger_DelegationRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ChainOfResponsibilityAnnotation chainOfResponsibility = null ;
      DelegationAnnotation delegation1 = null ;
      DelegationAnnotation delegation2 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsDelegation2 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod6 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization3 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsReference7 = null ;
      Iterator fujaba__IterConcreteHandle2AnnotationsOverridingMethod5 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization4 = null ;
      Iterator fujaba__IterDelegation1ElementsAbstractHandle = null ;
      Iterator fujaba__IterDelegation1ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterDelegation2ElementsConcreteHandle1 = null ;
      GeneralizationAnnotation generalization3 = null ;
      GeneralizationAnnotation generalization4 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod5 = null ;
      OverridingMethodAnnotation overridingMethod6 = null ;
      ReferenceAnnotation reference7 = null ;
      UMLClass abstractHandler = null ;
      UMLClass concreteHandler1 = null ;
      UMLClass concreteHandler2 = null ;
      UMLMethod abstractHandle = null ;
      UMLMethod concreteHandle1 = null ;
      UMLMethod concreteHandle2 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Delegation", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation1 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterDelegation1ElementsConcreteHandle2 = delegation1.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation1ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation1ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterDelegation1ElementsAbstractHandle = delegation1.iteratorOfElements ("callee") ;
                  while ( fujaba__IterDelegation1ElementsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterDelegation1ElementsAbstractHandle.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        abstractHandle = (UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                         
                        // bind abstractHandler: UMLClass
                        abstractHandler = abstractHandle.getParent () ;
                        JavaSDM.ensure ( abstractHandler != null ) ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                         
                        // bind overridingMethod5: OverridingMethodAnnotation
                        fujaba__IterConcreteHandle2AnnotationsOverridingMethod5 = concreteHandle2.iteratorOfAnnotations () ;
                        while ( fujaba__IterConcreteHandle2AnnotationsOverridingMethod5.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterConcreteHandle2AnnotationsOverridingMethod5.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod5 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod5 and concreteHandle2
                              JavaSDM.ensure ( overridingMethod5.hasInElements ("overriding", concreteHandle2) ) ;
                               
                              // check To-Many-Link 'elements' between overridingMethod5 and abstractHandle
                              JavaSDM.ensure ( overridingMethod5.hasInElements ("overridden", abstractHandle) ) ;
                               
                              // bind generalization4: GeneralizationAnnotation
                              fujaba__IterConcreteHandler2AnnotationsGeneralization4 = concreteHandler2.iteratorOfAnnotations () ;
                              while ( fujaba__IterConcreteHandler2AnnotationsGeneralization4.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization4.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization4 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization4 and concreteHandler2
                                    JavaSDM.ensure ( generalization4.hasInElements ("subClass", concreteHandler2) ) ;
                                     
                                    // check To-Many-Link 'elements' between generalization4 and abstractHandler
                                    JavaSDM.ensure ( generalization4.hasInElements ("superClass", abstractHandler) ) ;
                                     
                                    // bind delegation2: DelegationAnnotation
                                    fujaba__IterAbstractHandleAnnotationsDelegation2 = abstractHandle.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAbstractHandleAnnotationsDelegation2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsDelegation2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                          delegation2 = (DelegationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between delegation2 and abstractHandle
                                          JavaSDM.ensure ( delegation2.hasInElements ("callee", abstractHandle) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(delegation1.equals (delegation2)) ) ;
                                           
                                          // bind overridingMethod6: OverridingMethodAnnotation
                                          fujaba__IterAbstractHandleAnnotationsOverridingMethod6 = abstractHandle.iteratorOfAnnotations () ;
                                          while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod6.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod6.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                overridingMethod6 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between overridingMethod6 and abstractHandle
                                                JavaSDM.ensure ( overridingMethod6.hasInElements ("overridden", abstractHandle) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(overridingMethod5.equals (overridingMethod6)) ) ;
                                                 
                                                // bind reference7: ReferenceAnnotation
                                                fujaba__IterAbstractHandlerAnnotationsReference7 = abstractHandler.iteratorOfAnnotations () ;
                                                while ( fujaba__IterAbstractHandlerAnnotationsReference7.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsReference7.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                                      reference7 = (ReferenceAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between reference7 and abstractHandler
                                                      JavaSDM.ensure ( reference7.hasInElements ("references", abstractHandler) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between reference7 and abstractHandler
                                                      JavaSDM.ensure ( reference7.hasInElements ("referencingClass", abstractHandler) ) ;
                                                       
                                                      // bind generalization3: GeneralizationAnnotation
                                                      fujaba__IterAbstractHandlerAnnotationsGeneralization3 = abstractHandler.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterAbstractHandlerAnnotationsGeneralization3.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization3.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                            generalization3 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between generalization3 and abstractHandler
                                                            JavaSDM.ensure ( generalization3.hasInElements ("superClass", abstractHandler) ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(generalization4.equals (generalization3)) ) ;
                                                             
                                                            // bind concreteHandle1: UMLMethod
                                                            fujaba__IterDelegation2ElementsConcreteHandle1 = delegation2.iteratorOfElements ("caller") ;
                                                            while ( fujaba__IterDelegation2ElementsConcreteHandle1.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterDelegation2ElementsConcreteHandle1.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                  concreteHandle1 = (UMLMethod) fujaba__TmpObject ;
                                                                   
                                                                  // attribute condition
                                                                  JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(concreteHandle2.equals (concreteHandle1)) && !(abstractHandle.equals (concreteHandle1)) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between overridingMethod6 and concreteHandle1
                                                                  JavaSDM.ensure ( overridingMethod6.hasInElements ("overriding", concreteHandle1) ) ;
                                                                   
                                                                  // bind concreteHandler1: UMLClass
                                                                  concreteHandler1 = concreteHandle1.getParent () ;
                                                                  JavaSDM.ensure ( concreteHandler1 != null ) ;
                                                                   
                                                                  // attribute condition
                                                                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) && !(concreteHandler2.equals (concreteHandler1)) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between generalization3 and concreteHandler1
                                                                  JavaSDM.ensure ( generalization3.hasInElements ("subClass", concreteHandler1) ) ;
                                                                   
                                                                  {
                                                                     //  for each flow
                                                                     try
                                                                     {
                                                                        fujaba__Success = false ;
                                                                         
                                                                        // check object abstractHandler is really bound
                                                                        JavaSDM.ensure ( abstractHandler != null ) ;
                                                                         
                                                                        // bind chainOfResponsibility: ChainOfResponsibilityAnnotation
                                                                        fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = abstractHandler.iteratorOfAnnotations () ;
                                                                        while ( !(fujaba__Success) && fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof ChainOfResponsibilityAnnotation ) ;
                                                                              chainOfResponsibility = (ChainOfResponsibilityAnnotation) fujaba__TmpObject ;
                                                                               
                                                                              // check Reverse-Qualified-Link 'elements' between chainOfResponsibility and abstractHandler
                                                                              JavaSDM.ensure ( chainOfResponsibility.hasInElements ("handler", abstractHandler) ) ;
                                                                               
                                                                              fujaba__Success = true ;
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                        fujaba__Success = false ;
                                                                     }
                                                                      
                                                                     if ( !(fujaba__Success) )
                                                                     {
                                                                        try
                                                                        {
                                                                           fujaba__Success = false ;
                                                                            
                                                                           // check object abstractHandler is really bound
                                                                           JavaSDM.ensure ( abstractHandler != null ) ;
                                                                            
                                                                           // check object concreteHandler2 is really bound
                                                                           JavaSDM.ensure ( concreteHandler2 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) ) ;
                                                                            
                                                                           // check object concreteHandle2 is really bound
                                                                           JavaSDM.ensure ( concreteHandle2 != null ) ;
                                                                            
                                                                           // check object abstractHandle is really bound
                                                                           JavaSDM.ensure ( abstractHandle != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                                                                            
                                                                           // check object concreteHandle1 is really bound
                                                                           JavaSDM.ensure ( concreteHandle1 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(concreteHandle2.equals (concreteHandle1)) && !(abstractHandle.equals (concreteHandle1)) ) ;
                                                                            
                                                                           // check object concreteHandler1 is really bound
                                                                           JavaSDM.ensure ( concreteHandler1 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) && !(concreteHandler2.equals (concreteHandler1)) ) ;
                                                                            
                                                                           // create object
                                                                           chainOfResponsibility = new ChainOfResponsibilityAnnotation ( ) ;
                                                                            
                                                                           // assign statement
                                                                           chainOfResponsibility.setClassification (1);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToElements ("handler", abstractHandler);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("abstractHandler", abstractHandler);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandler2", concreteHandler2);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandle2", concreteHandle2);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("abstractHandle", abstractHandle);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandle1", concreteHandle1);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandler1", concreteHandler1);
                                                                            
                                                                           fujaba__Success = true ;
                                                                        }
                                                                        catch ( JavaSDMException fujaba__InternalException )
                                                                        {
                                                                           fujaba__Success = false ;
                                                                        }
                                                                         
                                                                        try
                                                                        {
                                                                           fujaba__Success = false ;
                                                                            
                                                                           // check object delegation1 is really bound
                                                                           JavaSDM.ensure ( delegation1 != null ) ;
                                                                            
                                                                           // check object delegation2 is really bound
                                                                           JavaSDM.ensure ( delegation2 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(delegation1.equals (delegation2)) ) ;
                                                                            
                                                                           // check object generalization3 is really bound
                                                                           JavaSDM.ensure ( generalization3 != null ) ;
                                                                            
                                                                           // check object generalization4 is really bound
                                                                           JavaSDM.ensure ( generalization4 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(generalization3.equals (generalization4)) ) ;
                                                                            
                                                                           // check object overridingMethod5 is really bound
                                                                           JavaSDM.ensure ( overridingMethod5 != null ) ;
                                                                            
                                                                           // check object overridingMethod6 is really bound
                                                                           JavaSDM.ensure ( overridingMethod6 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(overridingMethod5.equals (overridingMethod6)) ) ;
                                                                            
                                                                           // check object reference7 is really bound
                                                                           JavaSDM.ensure ( reference7 != null ) ;
                                                                            
                                                                           // check object chainOfResponsibility is really bound
                                                                           JavaSDM.ensure ( chainOfResponsibility != null ) ;
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (delegation1);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (delegation2);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (generalization3);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (generalization4);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (overridingMethod5);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (overridingMethod6);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (reference7);
                                                                            
                                                                           fujaba__Success = true ;
                                                                        }
                                                                        catch ( JavaSDMException fujaba__InternalException )
                                                                        {
                                                                           fujaba__Success = false ;
                                                                        }
                                                                         
                                                                        return (chainOfResponsibility) ;
                                                                     }
                                                                  } //  end for each flow
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object chainOfResponsibility is really bound
            JavaSDM.ensure ( chainOfResponsibility != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_Delegation", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (chainOfResponsibility) ;
   }


   private GFRNAnnotation annotateUsingTrigger_GeneralizationRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ChainOfResponsibilityAnnotation chainOfResponsibility = null ;
      DelegationAnnotation delegation15 = null ;
      DelegationAnnotation delegation16 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsDelegation15 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod19 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization18 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsReference21 = null ;
      Iterator fujaba__IterAbstractHandlerMethodsAbstractHandle = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsDelegation16 = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsOverridingMethod20 = null ;
      Iterator fujaba__IterConcreteHandler1MethodsConcreteHandle1 = null ;
      Iterator fujaba__IterGeneralization17ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization17ElementsConcreteHandler1 = null ;
      Iterator fujaba__IterGeneralization18ElementsConcreteHandler2 = null ;
      Iterator fujaba__IterOverridingMethod19ElementsConcreteHandle2 = null ;
      GeneralizationAnnotation generalization17 = null ;
      GeneralizationAnnotation generalization18 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod19 = null ;
      OverridingMethodAnnotation overridingMethod20 = null ;
      ReferenceAnnotation reference21 = null ;
      UMLClass abstractHandler = null ;
      UMLClass concreteHandler1 = null ;
      UMLClass concreteHandler2 = null ;
      UMLMethod abstractHandle = null ;
      UMLMethod concreteHandle1 = null ;
      UMLMethod concreteHandle2 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization17 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandler1: UMLClass
            fujaba__IterGeneralization17ElementsConcreteHandler1 = generalization17.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization17ElementsConcreteHandler1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization17ElementsConcreteHandler1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteHandler1 = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                   
                  // bind abstractHandler: UMLClass
                  fujaba__IterGeneralization17ElementsAbstractHandler = generalization17.iteratorOfElements ("superClass") ;
                  while ( fujaba__IterGeneralization17ElementsAbstractHandler.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization17ElementsAbstractHandler.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        abstractHandler = (UMLClass) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(concreteHandler1.equals (abstractHandler)) ) ;
                         
                        // bind concreteHandle1: UMLMethod
                        fujaba__IterConcreteHandler1MethodsConcreteHandle1 = concreteHandler1.iteratorOfMethods () ;
                        while ( fujaba__IterConcreteHandler1MethodsConcreteHandle1.hasNext () )
                        {
                           try
                           {
                              concreteHandle1 = (UMLMethod) fujaba__IterConcreteHandler1MethodsConcreteHandle1.next () ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                               
                              // bind abstractHandle: UMLMethod
                              fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                              while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                              {
                                 try
                                 {
                                    abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteHandle1.equals (abstractHandle)) ) ;
                                     
                                    // bind generalization18: GeneralizationAnnotation
                                    fujaba__IterAbstractHandlerAnnotationsGeneralization18 = abstractHandler.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAbstractHandlerAnnotationsGeneralization18.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization18.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                          generalization18 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between generalization18 and abstractHandler
                                          JavaSDM.ensure ( generalization18.hasInElements ("superClass", abstractHandler) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(generalization17.equals (generalization18)) ) ;
                                           
                                          // bind reference21: ReferenceAnnotation
                                          fujaba__IterAbstractHandlerAnnotationsReference21 = abstractHandler.iteratorOfAnnotations () ;
                                          while ( fujaba__IterAbstractHandlerAnnotationsReference21.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsReference21.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                                reference21 = (ReferenceAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between reference21 and abstractHandler
                                                JavaSDM.ensure ( reference21.hasInElements ("references", abstractHandler) ) ;
                                                 
                                                // check To-Many-Link 'elements' between reference21 and abstractHandler
                                                JavaSDM.ensure ( reference21.hasInElements ("referencingClass", abstractHandler) ) ;
                                                 
                                                // bind overridingMethod20: OverridingMethodAnnotation
                                                fujaba__IterConcreteHandle1AnnotationsOverridingMethod20 = concreteHandle1.iteratorOfAnnotations () ;
                                                while ( fujaba__IterConcreteHandle1AnnotationsOverridingMethod20.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsOverridingMethod20.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                      overridingMethod20 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between overridingMethod20 and concreteHandle1
                                                      JavaSDM.ensure ( overridingMethod20.hasInElements ("overriding", concreteHandle1) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between overridingMethod20 and abstractHandle
                                                      JavaSDM.ensure ( overridingMethod20.hasInElements ("overridden", abstractHandle) ) ;
                                                       
                                                      // bind delegation16: DelegationAnnotation
                                                      fujaba__IterConcreteHandle1AnnotationsDelegation16 = concreteHandle1.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterConcreteHandle1AnnotationsDelegation16.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsDelegation16.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                            delegation16 = (DelegationAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between delegation16 and concreteHandle1
                                                            JavaSDM.ensure ( delegation16.hasInElements ("caller", concreteHandle1) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between delegation16 and abstractHandle
                                                            JavaSDM.ensure ( delegation16.hasInElements ("callee", abstractHandle) ) ;
                                                             
                                                            // bind overridingMethod19: OverridingMethodAnnotation
                                                            fujaba__IterAbstractHandleAnnotationsOverridingMethod19 = abstractHandle.iteratorOfAnnotations () ;
                                                            while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod19.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod19.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                                  overridingMethod19 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between overridingMethod19 and abstractHandle
                                                                  JavaSDM.ensure ( overridingMethod19.hasInElements ("overridden", abstractHandle) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(overridingMethod20.equals (overridingMethod19)) ) ;
                                                                   
                                                                  // bind delegation15: DelegationAnnotation
                                                                  fujaba__IterAbstractHandleAnnotationsDelegation15 = abstractHandle.iteratorOfAnnotations () ;
                                                                  while ( fujaba__IterAbstractHandleAnnotationsDelegation15.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsDelegation15.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                                        delegation15 = (DelegationAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between delegation15 and abstractHandle
                                                                        JavaSDM.ensure ( delegation15.hasInElements ("callee", abstractHandle) ) ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(delegation16.equals (delegation15)) ) ;
                                                                         
                                                                        // bind concreteHandler2: UMLClass
                                                                        fujaba__IterGeneralization18ElementsConcreteHandler2 = generalization18.iteratorOfElements ("subClass") ;
                                                                        while ( fujaba__IterGeneralization18ElementsConcreteHandler2.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterGeneralization18ElementsConcreteHandler2.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                                              concreteHandler2 = (UMLClass) fujaba__TmpObject ;
                                                                               
                                                                              // attribute condition
                                                                              JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) && !(concreteHandler1.equals (concreteHandler2)) ) ;
                                                                               
                                                                              // bind concreteHandle2: UMLMethod
                                                                              fujaba__IterOverridingMethod19ElementsConcreteHandle2 = overridingMethod19.iteratorOfElements ("overriding") ;
                                                                              while ( fujaba__IterOverridingMethod19ElementsConcreteHandle2.hasNext () )
                                                                              {
                                                                                 try
                                                                                 {
                                                                                    fujaba__TmpObject = fujaba__IterOverridingMethod19ElementsConcreteHandle2.next () ;
                                                                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                                    concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                                                                                     
                                                                                    // attribute condition
                                                                                    JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle2)) && !(concreteHandle1.equals (concreteHandle2)) ) ;
                                                                                     
                                                                                    // check To-One-Link 'parent' between concreteHandle2 and concreteHandler2
                                                                                    JavaSDM.ensure ( (concreteHandle2.getParent () != null) && concreteHandle2.getParent ().equals (concreteHandler2) ) ;
                                                                                     
                                                                                    // check To-Many-Link 'elements' between delegation15 and concreteHandle2
                                                                                    JavaSDM.ensure ( delegation15.hasInElements ("caller", concreteHandle2) ) ;
                                                                                     
                                                                                    {
                                                                                       //  for each flow
                                                                                       try
                                                                                       {
                                                                                          fujaba__Success = false ;
                                                                                           
                                                                                          // check object abstractHandler is really bound
                                                                                          JavaSDM.ensure ( abstractHandler != null ) ;
                                                                                           
                                                                                          // bind chainOfResponsibility: ChainOfResponsibilityAnnotation
                                                                                          fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = abstractHandler.iteratorOfAnnotations () ;
                                                                                          while ( !(fujaba__Success) && fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.hasNext () )
                                                                                          {
                                                                                             try
                                                                                             {
                                                                                                fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.next () ;
                                                                                                JavaSDM.ensure ( fujaba__TmpObject instanceof ChainOfResponsibilityAnnotation ) ;
                                                                                                chainOfResponsibility = (ChainOfResponsibilityAnnotation) fujaba__TmpObject ;
                                                                                                 
                                                                                                // check Reverse-Qualified-Link 'elements' between chainOfResponsibility and abstractHandler
                                                                                                JavaSDM.ensure ( chainOfResponsibility.hasInElements ("handler", abstractHandler) ) ;
                                                                                                 
                                                                                                fujaba__Success = true ;
                                                                                             }
                                                                                             catch ( JavaSDMException fujaba__InternalException )
                                                                                             {
                                                                                             }
                                                                                          }
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                          fujaba__Success = false ;
                                                                                       }
                                                                                        
                                                                                       if ( !(fujaba__Success) )
                                                                                       {
                                                                                          try
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                              
                                                                                             // check object abstractHandler is really bound
                                                                                             JavaSDM.ensure ( abstractHandler != null ) ;
                                                                                              
                                                                                             // check object concreteHandler2 is really bound
                                                                                             JavaSDM.ensure ( concreteHandler2 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) ) ;
                                                                                              
                                                                                             // check object concreteHandle2 is really bound
                                                                                             JavaSDM.ensure ( concreteHandle2 != null ) ;
                                                                                              
                                                                                             // check object abstractHandle is really bound
                                                                                             JavaSDM.ensure ( abstractHandle != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                                                                                              
                                                                                             // check object concreteHandle1 is really bound
                                                                                             JavaSDM.ensure ( concreteHandle1 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(concreteHandle2.equals (concreteHandle1)) && !(abstractHandle.equals (concreteHandle1)) ) ;
                                                                                              
                                                                                             // check object concreteHandler1 is really bound
                                                                                             JavaSDM.ensure ( concreteHandler1 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) && !(concreteHandler2.equals (concreteHandler1)) ) ;
                                                                                              
                                                                                             // create object
                                                                                             chainOfResponsibility = new ChainOfResponsibilityAnnotation ( ) ;
                                                                                              
                                                                                             // assign statement
                                                                                             chainOfResponsibility.setClassification (1);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToElements ("handler", abstractHandler);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("abstractHandler", abstractHandler);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandler2", concreteHandler2);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandle2", concreteHandle2);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("abstractHandle", abstractHandle);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandle1", concreteHandle1);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandler1", concreteHandler1);
                                                                                              
                                                                                             fujaba__Success = true ;
                                                                                          }
                                                                                          catch ( JavaSDMException fujaba__InternalException )
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                          }
                                                                                           
                                                                                          try
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                              
                                                                                             // check object delegation15 is really bound
                                                                                             JavaSDM.ensure ( delegation15 != null ) ;
                                                                                              
                                                                                             // check object delegation16 is really bound
                                                                                             JavaSDM.ensure ( delegation16 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(delegation15.equals (delegation16)) ) ;
                                                                                              
                                                                                             // check object generalization17 is really bound
                                                                                             JavaSDM.ensure ( generalization17 != null ) ;
                                                                                              
                                                                                             // check object generalization18 is really bound
                                                                                             JavaSDM.ensure ( generalization18 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(generalization17.equals (generalization18)) ) ;
                                                                                              
                                                                                             // check object overridingMethod19 is really bound
                                                                                             JavaSDM.ensure ( overridingMethod19 != null ) ;
                                                                                              
                                                                                             // check object overridingMethod20 is really bound
                                                                                             JavaSDM.ensure ( overridingMethod20 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(overridingMethod19.equals (overridingMethod20)) ) ;
                                                                                              
                                                                                             // check object reference21 is really bound
                                                                                             JavaSDM.ensure ( reference21 != null ) ;
                                                                                              
                                                                                             // check object chainOfResponsibility is really bound
                                                                                             JavaSDM.ensure ( chainOfResponsibility != null ) ;
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (delegation15);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (delegation16);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (generalization17);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (generalization18);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (overridingMethod19);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (overridingMethod20);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (reference21);
                                                                                              
                                                                                             fujaba__Success = true ;
                                                                                          }
                                                                                          catch ( JavaSDMException fujaba__InternalException )
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                          }
                                                                                           
                                                                                          return (chainOfResponsibility) ;
                                                                                       }
                                                                                    } //  end for each flow
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                 }
                                                                              }
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object chainOfResponsibility is really bound
            JavaSDM.ensure ( chainOfResponsibility != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_Generalization", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (chainOfResponsibility) ;
   }


   private GFRNAnnotation annotateUsingTrigger_OverridingMethodRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ChainOfResponsibilityAnnotation chainOfResponsibility = null ;
      DelegationAnnotation delegation36 = null ;
      DelegationAnnotation delegation37 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsDelegation37 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod41 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization38 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsReference42 = null ;
      Iterator fujaba__IterConcreteHandle2AnnotationsDelegation36 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization39 = null ;
      Iterator fujaba__IterDelegation37ElementsConcreteHandle1 = null ;
      Iterator fujaba__IterOverridingMethod40ElementsAbstractHandle = null ;
      Iterator fujaba__IterOverridingMethod40ElementsConcreteHandle2 = null ;
      GeneralizationAnnotation generalization38 = null ;
      GeneralizationAnnotation generalization39 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod40 = null ;
      OverridingMethodAnnotation overridingMethod41 = null ;
      ReferenceAnnotation reference42 = null ;
      UMLClass abstractHandler = null ;
      UMLClass concreteHandler1 = null ;
      UMLClass concreteHandler2 = null ;
      UMLMethod abstractHandle = null ;
      UMLMethod concreteHandle1 = null ;
      UMLMethod concreteHandle2 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_OverridingMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod40 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterOverridingMethod40ElementsConcreteHandle2 = overridingMethod40.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod40ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod40ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterOverridingMethod40ElementsAbstractHandle = overridingMethod40.iteratorOfElements ("overridden") ;
                  while ( fujaba__IterOverridingMethod40ElementsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOverridingMethod40ElementsAbstractHandle.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        abstractHandle = (UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                         
                        // bind abstractHandler: UMLClass
                        abstractHandler = abstractHandle.getParent () ;
                        JavaSDM.ensure ( abstractHandler != null ) ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                         
                        // bind delegation36: DelegationAnnotation
                        fujaba__IterConcreteHandle2AnnotationsDelegation36 = concreteHandle2.iteratorOfAnnotations () ;
                        while ( fujaba__IterConcreteHandle2AnnotationsDelegation36.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterConcreteHandle2AnnotationsDelegation36.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                              delegation36 = (DelegationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between delegation36 and concreteHandle2
                              JavaSDM.ensure ( delegation36.hasInElements ("caller", concreteHandle2) ) ;
                               
                              // check To-Many-Link 'elements' between delegation36 and abstractHandle
                              JavaSDM.ensure ( delegation36.hasInElements ("callee", abstractHandle) ) ;
                               
                              // bind generalization39: GeneralizationAnnotation
                              fujaba__IterConcreteHandler2AnnotationsGeneralization39 = concreteHandler2.iteratorOfAnnotations () ;
                              while ( fujaba__IterConcreteHandler2AnnotationsGeneralization39.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization39.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization39 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization39 and concreteHandler2
                                    JavaSDM.ensure ( generalization39.hasInElements ("subClass", concreteHandler2) ) ;
                                     
                                    // check To-Many-Link 'elements' between generalization39 and abstractHandler
                                    JavaSDM.ensure ( generalization39.hasInElements ("superClass", abstractHandler) ) ;
                                     
                                    // bind delegation37: DelegationAnnotation
                                    fujaba__IterAbstractHandleAnnotationsDelegation37 = abstractHandle.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAbstractHandleAnnotationsDelegation37.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsDelegation37.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                          delegation37 = (DelegationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between delegation37 and abstractHandle
                                          JavaSDM.ensure ( delegation37.hasInElements ("callee", abstractHandle) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(delegation36.equals (delegation37)) ) ;
                                           
                                          // bind overridingMethod41: OverridingMethodAnnotation
                                          fujaba__IterAbstractHandleAnnotationsOverridingMethod41 = abstractHandle.iteratorOfAnnotations () ;
                                          while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod41.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod41.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                overridingMethod41 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between overridingMethod41 and abstractHandle
                                                JavaSDM.ensure ( overridingMethod41.hasInElements ("overridden", abstractHandle) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(overridingMethod40.equals (overridingMethod41)) ) ;
                                                 
                                                // bind reference42: ReferenceAnnotation
                                                fujaba__IterAbstractHandlerAnnotationsReference42 = abstractHandler.iteratorOfAnnotations () ;
                                                while ( fujaba__IterAbstractHandlerAnnotationsReference42.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsReference42.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                                      reference42 = (ReferenceAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between reference42 and abstractHandler
                                                      JavaSDM.ensure ( reference42.hasInElements ("references", abstractHandler) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between reference42 and abstractHandler
                                                      JavaSDM.ensure ( reference42.hasInElements ("referencingClass", abstractHandler) ) ;
                                                       
                                                      // bind generalization38: GeneralizationAnnotation
                                                      fujaba__IterAbstractHandlerAnnotationsGeneralization38 = abstractHandler.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterAbstractHandlerAnnotationsGeneralization38.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization38.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                            generalization38 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between generalization38 and abstractHandler
                                                            JavaSDM.ensure ( generalization38.hasInElements ("superClass", abstractHandler) ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(generalization39.equals (generalization38)) ) ;
                                                             
                                                            // bind concreteHandle1: UMLMethod
                                                            fujaba__IterDelegation37ElementsConcreteHandle1 = delegation37.iteratorOfElements ("caller") ;
                                                            while ( fujaba__IterDelegation37ElementsConcreteHandle1.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterDelegation37ElementsConcreteHandle1.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                  concreteHandle1 = (UMLMethod) fujaba__TmpObject ;
                                                                   
                                                                  // attribute condition
                                                                  JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(concreteHandle2.equals (concreteHandle1)) && !(abstractHandle.equals (concreteHandle1)) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between overridingMethod41 and concreteHandle1
                                                                  JavaSDM.ensure ( overridingMethod41.hasInElements ("overriding", concreteHandle1) ) ;
                                                                   
                                                                  // bind concreteHandler1: UMLClass
                                                                  concreteHandler1 = concreteHandle1.getParent () ;
                                                                  JavaSDM.ensure ( concreteHandler1 != null ) ;
                                                                   
                                                                  // attribute condition
                                                                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) && !(concreteHandler2.equals (concreteHandler1)) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between generalization38 and concreteHandler1
                                                                  JavaSDM.ensure ( generalization38.hasInElements ("subClass", concreteHandler1) ) ;
                                                                   
                                                                  {
                                                                     //  for each flow
                                                                     try
                                                                     {
                                                                        fujaba__Success = false ;
                                                                         
                                                                        // check object abstractHandler is really bound
                                                                        JavaSDM.ensure ( abstractHandler != null ) ;
                                                                         
                                                                        // bind chainOfResponsibility: ChainOfResponsibilityAnnotation
                                                                        fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = abstractHandler.iteratorOfAnnotations () ;
                                                                        while ( !(fujaba__Success) && fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof ChainOfResponsibilityAnnotation ) ;
                                                                              chainOfResponsibility = (ChainOfResponsibilityAnnotation) fujaba__TmpObject ;
                                                                               
                                                                              // check Reverse-Qualified-Link 'elements' between chainOfResponsibility and abstractHandler
                                                                              JavaSDM.ensure ( chainOfResponsibility.hasInElements ("handler", abstractHandler) ) ;
                                                                               
                                                                              fujaba__Success = true ;
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                        fujaba__Success = false ;
                                                                     }
                                                                      
                                                                     if ( !(fujaba__Success) )
                                                                     {
                                                                        try
                                                                        {
                                                                           fujaba__Success = false ;
                                                                            
                                                                           // check object abstractHandler is really bound
                                                                           JavaSDM.ensure ( abstractHandler != null ) ;
                                                                            
                                                                           // check object concreteHandler2 is really bound
                                                                           JavaSDM.ensure ( concreteHandler2 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) ) ;
                                                                            
                                                                           // check object concreteHandle2 is really bound
                                                                           JavaSDM.ensure ( concreteHandle2 != null ) ;
                                                                            
                                                                           // check object abstractHandle is really bound
                                                                           JavaSDM.ensure ( abstractHandle != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                                                                            
                                                                           // check object concreteHandle1 is really bound
                                                                           JavaSDM.ensure ( concreteHandle1 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(concreteHandle2.equals (concreteHandle1)) && !(abstractHandle.equals (concreteHandle1)) ) ;
                                                                            
                                                                           // check object concreteHandler1 is really bound
                                                                           JavaSDM.ensure ( concreteHandler1 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) && !(concreteHandler2.equals (concreteHandler1)) ) ;
                                                                            
                                                                           // create object
                                                                           chainOfResponsibility = new ChainOfResponsibilityAnnotation ( ) ;
                                                                            
                                                                           // assign statement
                                                                           chainOfResponsibility.setClassification (1);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToElements ("handler", abstractHandler);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("abstractHandler", abstractHandler);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandler2", concreteHandler2);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandle2", concreteHandle2);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("abstractHandle", abstractHandle);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandle1", concreteHandle1);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandler1", concreteHandler1);
                                                                            
                                                                           fujaba__Success = true ;
                                                                        }
                                                                        catch ( JavaSDMException fujaba__InternalException )
                                                                        {
                                                                           fujaba__Success = false ;
                                                                        }
                                                                         
                                                                        try
                                                                        {
                                                                           fujaba__Success = false ;
                                                                            
                                                                           // check object delegation36 is really bound
                                                                           JavaSDM.ensure ( delegation36 != null ) ;
                                                                            
                                                                           // check object delegation37 is really bound
                                                                           JavaSDM.ensure ( delegation37 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(delegation36.equals (delegation37)) ) ;
                                                                            
                                                                           // check object generalization38 is really bound
                                                                           JavaSDM.ensure ( generalization38 != null ) ;
                                                                            
                                                                           // check object generalization39 is really bound
                                                                           JavaSDM.ensure ( generalization39 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(generalization38.equals (generalization39)) ) ;
                                                                            
                                                                           // check object overridingMethod40 is really bound
                                                                           JavaSDM.ensure ( overridingMethod40 != null ) ;
                                                                            
                                                                           // check object overridingMethod41 is really bound
                                                                           JavaSDM.ensure ( overridingMethod41 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(overridingMethod40.equals (overridingMethod41)) ) ;
                                                                            
                                                                           // check object reference42 is really bound
                                                                           JavaSDM.ensure ( reference42 != null ) ;
                                                                            
                                                                           // check object chainOfResponsibility is really bound
                                                                           JavaSDM.ensure ( chainOfResponsibility != null ) ;
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (delegation36);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (delegation37);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (generalization38);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (generalization39);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (overridingMethod40);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (overridingMethod41);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (reference42);
                                                                            
                                                                           fujaba__Success = true ;
                                                                        }
                                                                        catch ( JavaSDMException fujaba__InternalException )
                                                                        {
                                                                           fujaba__Success = false ;
                                                                        }
                                                                         
                                                                        return (chainOfResponsibility) ;
                                                                     }
                                                                  } //  end for each flow
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object chainOfResponsibility is really bound
            JavaSDM.ensure ( chainOfResponsibility != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_OverridingMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (chainOfResponsibility) ;
   }


   private GFRNAnnotation annotateUsingTrigger_ReferenceRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ChainOfResponsibilityAnnotation chainOfResponsibility = null ;
      DelegationAnnotation delegation50 = null ;
      DelegationAnnotation delegation51 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsDelegation50 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsDelegation51 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod54 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod55 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization52 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization53 = null ;
      Iterator fujaba__IterAbstractHandlerMethodsAbstractHandle = null ;
      Iterator fujaba__IterDelegation51ElementsConcreteHandle1 = null ;
      Iterator fujaba__IterGeneralization52ElementsConcreteHandler1 = null ;
      Iterator fujaba__IterGeneralization53ElementsConcreteHandler2 = null ;
      Iterator fujaba__IterOverridingMethod54ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterReference56ElementsAbstractHandler = null ;
      GeneralizationAnnotation generalization52 = null ;
      GeneralizationAnnotation generalization53 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod54 = null ;
      OverridingMethodAnnotation overridingMethod55 = null ;
      ReferenceAnnotation reference56 = null ;
      UMLClass abstractHandler = null ;
      UMLClass concreteHandler1 = null ;
      UMLClass concreteHandler2 = null ;
      UMLMethod abstractHandle = null ;
      UMLMethod concreteHandle1 = null ;
      UMLMethod concreteHandle2 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Reference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference56 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterReference56ElementsAbstractHandler = reference56.iteratorOfElements ("references") ;
            while ( fujaba__IterReference56ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference56ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  // check To-Many-Link 'elements' between reference56 and abstractHandler
                  JavaSDM.ensure ( reference56.hasInElements ("referencingClass", abstractHandler) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        // bind generalization53: GeneralizationAnnotation
                        fujaba__IterAbstractHandlerAnnotationsGeneralization53 = abstractHandler.iteratorOfAnnotations () ;
                        while ( fujaba__IterAbstractHandlerAnnotationsGeneralization53.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization53.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization53 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization53 and abstractHandler
                              JavaSDM.ensure ( generalization53.hasInElements ("superClass", abstractHandler) ) ;
                               
                              // bind generalization52: GeneralizationAnnotation
                              fujaba__IterAbstractHandlerAnnotationsGeneralization52 = abstractHandler.iteratorOfAnnotations () ;
                              while ( fujaba__IterAbstractHandlerAnnotationsGeneralization52.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization52.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization52 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization52 and abstractHandler
                                    JavaSDM.ensure ( generalization52.hasInElements ("superClass", abstractHandler) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(generalization53.equals (generalization52)) ) ;
                                     
                                    // bind overridingMethod54: OverridingMethodAnnotation
                                    fujaba__IterAbstractHandleAnnotationsOverridingMethod54 = abstractHandle.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod54.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod54.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                          overridingMethod54 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between overridingMethod54 and abstractHandle
                                          JavaSDM.ensure ( overridingMethod54.hasInElements ("overridden", abstractHandle) ) ;
                                           
                                          // bind delegation50: DelegationAnnotation
                                          fujaba__IterAbstractHandleAnnotationsDelegation50 = abstractHandle.iteratorOfAnnotations () ;
                                          while ( fujaba__IterAbstractHandleAnnotationsDelegation50.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsDelegation50.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                delegation50 = (DelegationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between delegation50 and abstractHandle
                                                JavaSDM.ensure ( delegation50.hasInElements ("callee", abstractHandle) ) ;
                                                 
                                                // bind delegation51: DelegationAnnotation
                                                fujaba__IterAbstractHandleAnnotationsDelegation51 = abstractHandle.iteratorOfAnnotations () ;
                                                while ( fujaba__IterAbstractHandleAnnotationsDelegation51.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsDelegation51.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                      delegation51 = (DelegationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between delegation51 and abstractHandle
                                                      JavaSDM.ensure ( delegation51.hasInElements ("callee", abstractHandle) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(delegation50.equals (delegation51)) ) ;
                                                       
                                                      // bind overridingMethod55: OverridingMethodAnnotation
                                                      fujaba__IterAbstractHandleAnnotationsOverridingMethod55 = abstractHandle.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod55.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod55.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                            overridingMethod55 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between overridingMethod55 and abstractHandle
                                                            JavaSDM.ensure ( overridingMethod55.hasInElements ("overridden", abstractHandle) ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(overridingMethod54.equals (overridingMethod55)) ) ;
                                                             
                                                            // bind concreteHandler2: UMLClass
                                                            fujaba__IterGeneralization53ElementsConcreteHandler2 = generalization53.iteratorOfElements ("subClass") ;
                                                            while ( fujaba__IterGeneralization53ElementsConcreteHandler2.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterGeneralization53ElementsConcreteHandler2.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                                  concreteHandler2 = (UMLClass) fujaba__TmpObject ;
                                                                   
                                                                  // attribute condition
                                                                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) ) ;
                                                                   
                                                                  // bind concreteHandler1: UMLClass
                                                                  fujaba__IterGeneralization52ElementsConcreteHandler1 = generalization52.iteratorOfElements ("subClass") ;
                                                                  while ( fujaba__IterGeneralization52ElementsConcreteHandler1.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterGeneralization52ElementsConcreteHandler1.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                                        concreteHandler1 = (UMLClass) fujaba__TmpObject ;
                                                                         
                                                                        // attribute condition
                                                                        JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) && !(concreteHandler2.equals (concreteHandler1)) ) ;
                                                                         
                                                                        // bind concreteHandle2: UMLMethod
                                                                        fujaba__IterOverridingMethod54ElementsConcreteHandle2 = overridingMethod54.iteratorOfElements ("overriding") ;
                                                                        while ( fujaba__IterOverridingMethod54ElementsConcreteHandle2.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterOverridingMethod54ElementsConcreteHandle2.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                              concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                                                                               
                                                                              // attribute condition
                                                                              JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle2)) ) ;
                                                                               
                                                                              // check To-One-Link 'parent' between concreteHandle2 and concreteHandler2
                                                                              JavaSDM.ensure ( (concreteHandle2.getParent () != null) && concreteHandle2.getParent ().equals (concreteHandler2) ) ;
                                                                               
                                                                              // check To-Many-Link 'elements' between delegation50 and concreteHandle2
                                                                              JavaSDM.ensure ( delegation50.hasInElements ("caller", concreteHandle2) ) ;
                                                                               
                                                                              // bind concreteHandle1: UMLMethod
                                                                              fujaba__IterDelegation51ElementsConcreteHandle1 = delegation51.iteratorOfElements ("caller") ;
                                                                              while ( fujaba__IterDelegation51ElementsConcreteHandle1.hasNext () )
                                                                              {
                                                                                 try
                                                                                 {
                                                                                    fujaba__TmpObject = fujaba__IterDelegation51ElementsConcreteHandle1.next () ;
                                                                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                                    concreteHandle1 = (UMLMethod) fujaba__TmpObject ;
                                                                                     
                                                                                    // attribute condition
                                                                                    JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(concreteHandle2.equals (concreteHandle1)) && !(abstractHandle.equals (concreteHandle1)) ) ;
                                                                                     
                                                                                    // check To-Many-Link 'elements' between overridingMethod55 and concreteHandle1
                                                                                    JavaSDM.ensure ( overridingMethod55.hasInElements ("overriding", concreteHandle1) ) ;
                                                                                     
                                                                                    // check To-One-Link 'parent' between concreteHandle1 and concreteHandler1
                                                                                    JavaSDM.ensure ( (concreteHandle1.getParent () != null) && concreteHandle1.getParent ().equals (concreteHandler1) ) ;
                                                                                     
                                                                                    {
                                                                                       //  for each flow
                                                                                       try
                                                                                       {
                                                                                          fujaba__Success = false ;
                                                                                           
                                                                                          // check object abstractHandler is really bound
                                                                                          JavaSDM.ensure ( abstractHandler != null ) ;
                                                                                           
                                                                                          // bind chainOfResponsibility: ChainOfResponsibilityAnnotation
                                                                                          fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = abstractHandler.iteratorOfAnnotations () ;
                                                                                          while ( !(fujaba__Success) && fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.hasNext () )
                                                                                          {
                                                                                             try
                                                                                             {
                                                                                                fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.next () ;
                                                                                                JavaSDM.ensure ( fujaba__TmpObject instanceof ChainOfResponsibilityAnnotation ) ;
                                                                                                chainOfResponsibility = (ChainOfResponsibilityAnnotation) fujaba__TmpObject ;
                                                                                                 
                                                                                                // check Reverse-Qualified-Link 'elements' between chainOfResponsibility and abstractHandler
                                                                                                JavaSDM.ensure ( chainOfResponsibility.hasInElements ("handler", abstractHandler) ) ;
                                                                                                 
                                                                                                fujaba__Success = true ;
                                                                                             }
                                                                                             catch ( JavaSDMException fujaba__InternalException )
                                                                                             {
                                                                                             }
                                                                                          }
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                          fujaba__Success = false ;
                                                                                       }
                                                                                        
                                                                                       if ( !(fujaba__Success) )
                                                                                       {
                                                                                          try
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                              
                                                                                             // check object abstractHandler is really bound
                                                                                             JavaSDM.ensure ( abstractHandler != null ) ;
                                                                                              
                                                                                             // check object concreteHandler2 is really bound
                                                                                             JavaSDM.ensure ( concreteHandler2 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) ) ;
                                                                                              
                                                                                             // check object concreteHandle2 is really bound
                                                                                             JavaSDM.ensure ( concreteHandle2 != null ) ;
                                                                                              
                                                                                             // check object abstractHandle is really bound
                                                                                             JavaSDM.ensure ( abstractHandle != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                                                                                              
                                                                                             // check object concreteHandle1 is really bound
                                                                                             JavaSDM.ensure ( concreteHandle1 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(concreteHandle2.equals (concreteHandle1)) && !(abstractHandle.equals (concreteHandle1)) ) ;
                                                                                              
                                                                                             // check object concreteHandler1 is really bound
                                                                                             JavaSDM.ensure ( concreteHandler1 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) && !(concreteHandler2.equals (concreteHandler1)) ) ;
                                                                                              
                                                                                             // create object
                                                                                             chainOfResponsibility = new ChainOfResponsibilityAnnotation ( ) ;
                                                                                              
                                                                                             // assign statement
                                                                                             chainOfResponsibility.setClassification (1);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToElements ("handler", abstractHandler);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("abstractHandler", abstractHandler);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandler2", concreteHandler2);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandle2", concreteHandle2);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("abstractHandle", abstractHandle);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandle1", concreteHandle1);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandler1", concreteHandler1);
                                                                                              
                                                                                             fujaba__Success = true ;
                                                                                          }
                                                                                          catch ( JavaSDMException fujaba__InternalException )
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                          }
                                                                                           
                                                                                          try
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                              
                                                                                             // check object delegation50 is really bound
                                                                                             JavaSDM.ensure ( delegation50 != null ) ;
                                                                                              
                                                                                             // check object delegation51 is really bound
                                                                                             JavaSDM.ensure ( delegation51 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(delegation50.equals (delegation51)) ) ;
                                                                                              
                                                                                             // check object generalization52 is really bound
                                                                                             JavaSDM.ensure ( generalization52 != null ) ;
                                                                                              
                                                                                             // check object generalization53 is really bound
                                                                                             JavaSDM.ensure ( generalization53 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(generalization52.equals (generalization53)) ) ;
                                                                                              
                                                                                             // check object overridingMethod54 is really bound
                                                                                             JavaSDM.ensure ( overridingMethod54 != null ) ;
                                                                                              
                                                                                             // check object overridingMethod55 is really bound
                                                                                             JavaSDM.ensure ( overridingMethod55 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(overridingMethod54.equals (overridingMethod55)) ) ;
                                                                                              
                                                                                             // check object reference56 is really bound
                                                                                             JavaSDM.ensure ( reference56 != null ) ;
                                                                                              
                                                                                             // check object chainOfResponsibility is really bound
                                                                                             JavaSDM.ensure ( chainOfResponsibility != null ) ;
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (delegation50);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (delegation51);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (generalization52);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (generalization53);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (overridingMethod54);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (overridingMethod55);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (reference56);
                                                                                              
                                                                                             fujaba__Success = true ;
                                                                                          }
                                                                                          catch ( JavaSDMException fujaba__InternalException )
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                          }
                                                                                           
                                                                                          return (chainOfResponsibility) ;
                                                                                       }
                                                                                    } //  end for each flow
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                 }
                                                                              }
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object chainOfResponsibility is really bound
            JavaSDM.ensure ( chainOfResponsibility != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_Reference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (chainOfResponsibility) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("handler", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof DelegationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Delegation", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof DelegationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Delegation", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OverridingMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_OverridingMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OverridingMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_OverridingMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Reference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      DelegationAnnotation delegation50 = null ;
      DelegationAnnotation delegation51 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod63 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod66 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod69 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod71 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod72 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod79 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod82 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod85 = null ;
      Iterator fujaba__IterAbstractHandlerMethodsAbstractHandle = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsOverridingMethod57 = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsOverridingMethod58 = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsOverridingMethod62 = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsOverridingMethod68 = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsOverridingMethod70 = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsOverridingMethod73 = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsOverridingMethod74 = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsOverridingMethod78 = null ;
      Iterator fujaba__IterConcreteHandle1AnnotationsOverridingMethod81 = null ;
      Iterator fujaba__IterConcreteHandler1MethodsConcreteHandle1 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization59 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization60 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization61 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization64 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization65 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization67 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization75 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization76 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization77 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization80 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization83 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization84 = null ;
      Iterator fujaba__IterConcreteHandler2AnnotationsGeneralization86 = null ;
      Iterator fujaba__IterDelegation50ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterDelegation51ElementsConcreteHandle1 = null ;
      Iterator fujaba__IterGeneralization52ElementsConcreteHandler1 = null ;
      Iterator fujaba__IterGeneralization53ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization59ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization60ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization61ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization64ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization65ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization67ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization75ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization76ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization77ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization80ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization83ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization84ElementsAbstractHandler = null ;
      Iterator fujaba__IterGeneralization86ElementsAbstractHandler = null ;
      Iterator fujaba__IterOverridingMethod54ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterOverridingMethod57ElementsAbstractHandle = null ;
      Iterator fujaba__IterOverridingMethod58ElementsAbstractHandle = null ;
      Iterator fujaba__IterOverridingMethod62ElementsAbstractHandle = null ;
      Iterator fujaba__IterOverridingMethod63ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterOverridingMethod66ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterOverridingMethod68ElementsAbstractHandle = null ;
      Iterator fujaba__IterOverridingMethod69ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterOverridingMethod70ElementsAbstractHandle = null ;
      Iterator fujaba__IterOverridingMethod71ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterOverridingMethod72ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterOverridingMethod73ElementsAbstractHandle = null ;
      Iterator fujaba__IterOverridingMethod74ElementsAbstractHandle = null ;
      Iterator fujaba__IterOverridingMethod78ElementsAbstractHandle = null ;
      Iterator fujaba__IterOverridingMethod79ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterOverridingMethod81ElementsAbstractHandle = null ;
      Iterator fujaba__IterOverridingMethod82ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterOverridingMethod85ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterReference56ElementsAbstractHandler = null ;
      GeneralizationAnnotation generalization52 = null ;
      GeneralizationAnnotation generalization53 = null ;
      GeneralizationAnnotation generalization59 = null ;
      GeneralizationAnnotation generalization60 = null ;
      GeneralizationAnnotation generalization61 = null ;
      GeneralizationAnnotation generalization64 = null ;
      GeneralizationAnnotation generalization65 = null ;
      GeneralizationAnnotation generalization67 = null ;
      GeneralizationAnnotation generalization75 = null ;
      GeneralizationAnnotation generalization76 = null ;
      GeneralizationAnnotation generalization77 = null ;
      GeneralizationAnnotation generalization80 = null ;
      GeneralizationAnnotation generalization83 = null ;
      GeneralizationAnnotation generalization84 = null ;
      GeneralizationAnnotation generalization86 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod54 = null ;
      OverridingMethodAnnotation overridingMethod57 = null ;
      OverridingMethodAnnotation overridingMethod58 = null ;
      OverridingMethodAnnotation overridingMethod62 = null ;
      OverridingMethodAnnotation overridingMethod63 = null ;
      OverridingMethodAnnotation overridingMethod66 = null ;
      OverridingMethodAnnotation overridingMethod68 = null ;
      OverridingMethodAnnotation overridingMethod69 = null ;
      OverridingMethodAnnotation overridingMethod70 = null ;
      OverridingMethodAnnotation overridingMethod71 = null ;
      OverridingMethodAnnotation overridingMethod72 = null ;
      OverridingMethodAnnotation overridingMethod73 = null ;
      OverridingMethodAnnotation overridingMethod74 = null ;
      OverridingMethodAnnotation overridingMethod78 = null ;
      OverridingMethodAnnotation overridingMethod79 = null ;
      OverridingMethodAnnotation overridingMethod81 = null ;
      OverridingMethodAnnotation overridingMethod82 = null ;
      OverridingMethodAnnotation overridingMethod85 = null ;
      ReferenceAnnotation reference56 = null ;
      UMLClass abstractHandler = null ;
      UMLClass concreteHandler1 = null ;
      UMLClass concreteHandler2 = null ;
      UMLMethod abstractHandle = null ;
      UMLMethod concreteHandle1 = null ;
      UMLMethod concreteHandle2 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Delegation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
            while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
            {
               try
               {
                  abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation51 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle1: UMLMethod
            fujaba__IterDelegation51ElementsConcreteHandle1 = delegation51.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation51ElementsConcreteHandle1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation51ElementsConcreteHandle1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                   
                  // bind overridingMethod57: OverridingMethodAnnotation
                  fujaba__IterConcreteHandle1AnnotationsOverridingMethod57 = concreteHandle1.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandle1AnnotationsOverridingMethod57.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsOverridingMethod57.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod57 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod57 and concreteHandle1
                        JavaSDM.ensure ( overridingMethod57.hasInElements ("overriding", concreteHandle1) ) ;
                         
                        // bind abstractHandle: UMLMethod
                        fujaba__IterOverridingMethod57ElementsAbstractHandle = overridingMethod57.iteratorOfElements ("overridden") ;
                        while ( fujaba__IterOverridingMethod57ElementsAbstractHandle.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOverridingMethod57ElementsAbstractHandle.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              abstractHandle = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandle1.equals (abstractHandle)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (abstractHandle);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization52 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandler1: UMLClass
            fujaba__IterGeneralization52ElementsConcreteHandler1 = generalization52.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization52ElementsConcreteHandler1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization52ElementsConcreteHandler1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteHandler1 = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                   
                  // bind concreteHandle1: UMLMethod
                  fujaba__IterConcreteHandler1MethodsConcreteHandle1 = concreteHandler1.iteratorOfMethods () ;
                  while ( fujaba__IterConcreteHandler1MethodsConcreteHandle1.hasNext () )
                  {
                     try
                     {
                        concreteHandle1 = (UMLMethod) fujaba__IterConcreteHandler1MethodsConcreteHandle1.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                         
                        // bind overridingMethod58: OverridingMethodAnnotation
                        fujaba__IterConcreteHandle1AnnotationsOverridingMethod58 = concreteHandle1.iteratorOfAnnotations () ;
                        while ( fujaba__IterConcreteHandle1AnnotationsOverridingMethod58.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsOverridingMethod58.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod58 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod58 and concreteHandle1
                              JavaSDM.ensure ( overridingMethod58.hasInElements ("overriding", concreteHandle1) ) ;
                               
                              // bind abstractHandle: UMLMethod
                              fujaba__IterOverridingMethod58ElementsAbstractHandle = overridingMethod58.iteratorOfElements ("overridden") ;
                              while ( fujaba__IterOverridingMethod58ElementsAbstractHandle.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOverridingMethod58ElementsAbstractHandle.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    abstractHandle = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteHandle1.equals (abstractHandle)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (abstractHandle);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization53 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterGeneralization53ElementsAbstractHandler = generalization53.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization53ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization53ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        {
                           //  for each flow
                           set.add (abstractHandle);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod54 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterOverridingMethod54ElementsConcreteHandle2 = overridingMethod54.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod54ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod54ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  {
                     //  for each flow
                     set.add (concreteHandle2);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod58 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterOverridingMethod58ElementsAbstractHandle = overridingMethod58.iteratorOfElements ("overridden") ;
            while ( fujaba__IterOverridingMethod58ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod58ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference56 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterReference56ElementsAbstractHandler = reference56.iteratorOfElements ("references") ;
            while ( fujaba__IterReference56ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference56ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        {
                           //  for each flow
                           set.add (abstractHandle);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Delegation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
            while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
            {
               try
               {
                  abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation50 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterDelegation50ElementsConcreteHandle2 = delegation50.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation50ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation50ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  // bind generalization59: GeneralizationAnnotation
                  fujaba__IterConcreteHandler2AnnotationsGeneralization59 = concreteHandler2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandler2AnnotationsGeneralization59.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization59.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization59 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization59 and concreteHandler2
                        JavaSDM.ensure ( generalization59.hasInElements ("subClass", concreteHandler2) ) ;
                         
                        // bind abstractHandler: UMLClass
                        fujaba__IterGeneralization59ElementsAbstractHandler = generalization59.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization59ElementsAbstractHandler.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization59ElementsAbstractHandler.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              abstractHandler = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                               
                              // bind abstractHandle: UMLMethod
                              fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                              while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                              {
                                 try
                                 {
                                    abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (abstractHandle);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization52 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandler1: UMLClass
            fujaba__IterGeneralization52ElementsConcreteHandler1 = generalization52.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization52ElementsConcreteHandler1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization52ElementsConcreteHandler1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteHandler1 = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                   
                  // bind concreteHandle1: UMLMethod
                  fujaba__IterConcreteHandler1MethodsConcreteHandle1 = concreteHandler1.iteratorOfMethods () ;
                  while ( fujaba__IterConcreteHandler1MethodsConcreteHandle1.hasNext () )
                  {
                     try
                     {
                        concreteHandle1 = (UMLMethod) fujaba__IterConcreteHandler1MethodsConcreteHandle1.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                         
                        {
                           //  for each flow
                           set.add (concreteHandle1);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization59 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterGeneralization59ElementsAbstractHandler = generalization59.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization59ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization59ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        {
                           //  for each flow
                           set.add (abstractHandle);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod54 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterOverridingMethod54ElementsConcreteHandle2 = overridingMethod54.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod54ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod54ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  // bind generalization60: GeneralizationAnnotation
                  fujaba__IterConcreteHandler2AnnotationsGeneralization60 = concreteHandler2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandler2AnnotationsGeneralization60.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization60.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization60 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization60 and concreteHandler2
                        JavaSDM.ensure ( generalization60.hasInElements ("subClass", concreteHandler2) ) ;
                         
                        // bind abstractHandler: UMLClass
                        fujaba__IterGeneralization60ElementsAbstractHandler = generalization60.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization60ElementsAbstractHandler.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization60ElementsAbstractHandler.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              abstractHandler = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                               
                              // bind abstractHandle: UMLMethod
                              fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                              while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                              {
                                 try
                                 {
                                    abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (abstractHandle);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod58 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterOverridingMethod58ElementsAbstractHandle = overridingMethod58.iteratorOfElements ("overridden") ;
            while ( fujaba__IterOverridingMethod58ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod58ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference56 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterReference56ElementsAbstractHandler = reference56.iteratorOfElements ("references") ;
            while ( fujaba__IterReference56ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference56ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        {
                           //  for each flow
                           set.add (abstractHandle);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") || annotation.equals ("MultiLevelGeneralization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstractHandler);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation50 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterDelegation50ElementsConcreteHandle2 = delegation50.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation50ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation50ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  // bind generalization61: GeneralizationAnnotation
                  fujaba__IterConcreteHandler2AnnotationsGeneralization61 = concreteHandler2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandler2AnnotationsGeneralization61.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization61.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization61 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization61 and concreteHandler2
                        JavaSDM.ensure ( generalization61.hasInElements ("subClass", concreteHandler2) ) ;
                         
                        // bind abstractHandler: UMLClass
                        fujaba__IterGeneralization61ElementsAbstractHandler = generalization61.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization61ElementsAbstractHandler.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization61ElementsAbstractHandler.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              abstractHandler = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (abstractHandler);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation51 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle1: UMLMethod
            fujaba__IterDelegation51ElementsConcreteHandle1 = delegation51.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation51ElementsConcreteHandle1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation51ElementsConcreteHandle1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                   
                  // bind overridingMethod62: OverridingMethodAnnotation
                  fujaba__IterConcreteHandle1AnnotationsOverridingMethod62 = concreteHandle1.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandle1AnnotationsOverridingMethod62.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsOverridingMethod62.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod62 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod62 and concreteHandle1
                        JavaSDM.ensure ( overridingMethod62.hasInElements ("overriding", concreteHandle1) ) ;
                         
                        // bind abstractHandle: UMLMethod
                        fujaba__IterOverridingMethod62ElementsAbstractHandle = overridingMethod62.iteratorOfElements ("overridden") ;
                        while ( fujaba__IterOverridingMethod62ElementsAbstractHandle.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOverridingMethod62ElementsAbstractHandle.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              abstractHandle = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandle1.equals (abstractHandle)) ) ;
                               
                              // bind overridingMethod63: OverridingMethodAnnotation
                              fujaba__IterAbstractHandleAnnotationsOverridingMethod63 = abstractHandle.iteratorOfAnnotations () ;
                              while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod63.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod63.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                    overridingMethod63 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between overridingMethod63 and abstractHandle
                                    JavaSDM.ensure ( overridingMethod63.hasInElements ("overridden", abstractHandle) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(overridingMethod62.equals (overridingMethod63)) ) ;
                                     
                                    // bind concreteHandle2: UMLMethod
                                    fujaba__IterOverridingMethod63ElementsConcreteHandle2 = overridingMethod63.iteratorOfElements ("overriding") ;
                                    while ( fujaba__IterOverridingMethod63ElementsConcreteHandle2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterOverridingMethod63ElementsConcreteHandle2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(concreteHandle1.equals (concreteHandle2)) && !(abstractHandle.equals (concreteHandle2)) ) ;
                                           
                                          // bind concreteHandler2: UMLClass
                                          concreteHandler2 = concreteHandle2.getParent () ;
                                          JavaSDM.ensure ( concreteHandler2 != null ) ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                                           
                                          // bind generalization64: GeneralizationAnnotation
                                          fujaba__IterConcreteHandler2AnnotationsGeneralization64 = concreteHandler2.iteratorOfAnnotations () ;
                                          while ( fujaba__IterConcreteHandler2AnnotationsGeneralization64.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization64.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                generalization64 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between generalization64 and concreteHandler2
                                                JavaSDM.ensure ( generalization64.hasInElements ("subClass", concreteHandler2) ) ;
                                                 
                                                // bind abstractHandler: UMLClass
                                                fujaba__IterGeneralization64ElementsAbstractHandler = generalization64.iteratorOfElements ("superClass") ;
                                                while ( fujaba__IterGeneralization64ElementsAbstractHandler.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterGeneralization64ElementsAbstractHandler.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                      abstractHandler = (UMLClass) fujaba__TmpObject ;
                                                       
                                                      // attribute condition
                                                      JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         set.add (abstractHandler);
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization64 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterGeneralization64ElementsAbstractHandler = generalization64.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization64ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization64ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandler);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod63 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterOverridingMethod63ElementsConcreteHandle2 = overridingMethod63.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod63ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod63ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  // bind generalization65: GeneralizationAnnotation
                  fujaba__IterConcreteHandler2AnnotationsGeneralization65 = concreteHandler2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandler2AnnotationsGeneralization65.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization65.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization65 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization65 and concreteHandler2
                        JavaSDM.ensure ( generalization65.hasInElements ("subClass", concreteHandler2) ) ;
                         
                        // bind abstractHandler: UMLClass
                        fujaba__IterGeneralization65ElementsAbstractHandler = generalization65.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization65ElementsAbstractHandler.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization65ElementsAbstractHandler.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              abstractHandler = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (abstractHandler);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod62 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterOverridingMethod62ElementsAbstractHandle = overridingMethod62.iteratorOfElements ("overridden") ;
            while ( fujaba__IterOverridingMethod62ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod62ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  // bind overridingMethod66: OverridingMethodAnnotation
                  fujaba__IterAbstractHandleAnnotationsOverridingMethod66 = abstractHandle.iteratorOfAnnotations () ;
                  while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod66.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod66.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod66 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod66 and abstractHandle
                        JavaSDM.ensure ( overridingMethod66.hasInElements ("overridden", abstractHandle) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(overridingMethod62.equals (overridingMethod66)) ) ;
                         
                        // bind concreteHandle2: UMLMethod
                        fujaba__IterOverridingMethod66ElementsConcreteHandle2 = overridingMethod66.iteratorOfElements ("overriding") ;
                        while ( fujaba__IterOverridingMethod66ElementsConcreteHandle2.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOverridingMethod66ElementsConcreteHandle2.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle2)) ) ;
                               
                              // bind concreteHandler2: UMLClass
                              concreteHandler2 = concreteHandle2.getParent () ;
                              JavaSDM.ensure ( concreteHandler2 != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                               
                              // bind generalization67: GeneralizationAnnotation
                              fujaba__IterConcreteHandler2AnnotationsGeneralization67 = concreteHandler2.iteratorOfAnnotations () ;
                              while ( fujaba__IterConcreteHandler2AnnotationsGeneralization67.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization67.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization67 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization67 and concreteHandler2
                                    JavaSDM.ensure ( generalization67.hasInElements ("subClass", concreteHandler2) ) ;
                                     
                                    // bind abstractHandler: UMLClass
                                    fujaba__IterGeneralization67ElementsAbstractHandler = generalization67.iteratorOfElements ("superClass") ;
                                    while ( fujaba__IterGeneralization67ElementsAbstractHandler.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization67ElementsAbstractHandler.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          abstractHandler = (UMLClass) fujaba__TmpObject ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                                           
                                          {
                                             //  for each flow
                                             set.add (abstractHandler);
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference56 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterReference56ElementsAbstractHandler = reference56.iteratorOfElements ("references") ;
            while ( fujaba__IterReference56ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference56ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandler);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") || annotation.equals ("MultiLevelGeneralization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstractHandler);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation50 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterDelegation50ElementsConcreteHandle2 = delegation50.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation50ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation50ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  {
                     //  for each flow
                     set.add (concreteHandler2);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation51 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle1: UMLMethod
            fujaba__IterDelegation51ElementsConcreteHandle1 = delegation51.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation51ElementsConcreteHandle1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation51ElementsConcreteHandle1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                   
                  // bind overridingMethod68: OverridingMethodAnnotation
                  fujaba__IterConcreteHandle1AnnotationsOverridingMethod68 = concreteHandle1.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandle1AnnotationsOverridingMethod68.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsOverridingMethod68.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod68 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod68 and concreteHandle1
                        JavaSDM.ensure ( overridingMethod68.hasInElements ("overriding", concreteHandle1) ) ;
                         
                        // bind abstractHandle: UMLMethod
                        fujaba__IterOverridingMethod68ElementsAbstractHandle = overridingMethod68.iteratorOfElements ("overridden") ;
                        while ( fujaba__IterOverridingMethod68ElementsAbstractHandle.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOverridingMethod68ElementsAbstractHandle.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              abstractHandle = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandle1.equals (abstractHandle)) ) ;
                               
                              // bind overridingMethod69: OverridingMethodAnnotation
                              fujaba__IterAbstractHandleAnnotationsOverridingMethod69 = abstractHandle.iteratorOfAnnotations () ;
                              while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod69.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod69.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                    overridingMethod69 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between overridingMethod69 and abstractHandle
                                    JavaSDM.ensure ( overridingMethod69.hasInElements ("overridden", abstractHandle) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(overridingMethod68.equals (overridingMethod69)) ) ;
                                     
                                    // bind concreteHandle2: UMLMethod
                                    fujaba__IterOverridingMethod69ElementsConcreteHandle2 = overridingMethod69.iteratorOfElements ("overriding") ;
                                    while ( fujaba__IterOverridingMethod69ElementsConcreteHandle2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterOverridingMethod69ElementsConcreteHandle2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(concreteHandle1.equals (concreteHandle2)) && !(abstractHandle.equals (concreteHandle2)) ) ;
                                           
                                          // bind concreteHandler2: UMLClass
                                          concreteHandler2 = concreteHandle2.getParent () ;
                                          JavaSDM.ensure ( concreteHandler2 != null ) ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                                           
                                          {
                                             //  for each flow
                                             set.add (concreteHandler2);
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization52 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandler1: UMLClass
            fujaba__IterGeneralization52ElementsConcreteHandler1 = generalization52.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization52ElementsConcreteHandler1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization52ElementsConcreteHandler1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteHandler1 = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                   
                  // bind concreteHandle1: UMLMethod
                  fujaba__IterConcreteHandler1MethodsConcreteHandle1 = concreteHandler1.iteratorOfMethods () ;
                  while ( fujaba__IterConcreteHandler1MethodsConcreteHandle1.hasNext () )
                  {
                     try
                     {
                        concreteHandle1 = (UMLMethod) fujaba__IterConcreteHandler1MethodsConcreteHandle1.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                         
                        // bind overridingMethod70: OverridingMethodAnnotation
                        fujaba__IterConcreteHandle1AnnotationsOverridingMethod70 = concreteHandle1.iteratorOfAnnotations () ;
                        while ( fujaba__IterConcreteHandle1AnnotationsOverridingMethod70.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsOverridingMethod70.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod70 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod70 and concreteHandle1
                              JavaSDM.ensure ( overridingMethod70.hasInElements ("overriding", concreteHandle1) ) ;
                               
                              // bind abstractHandle: UMLMethod
                              fujaba__IterOverridingMethod70ElementsAbstractHandle = overridingMethod70.iteratorOfElements ("overridden") ;
                              while ( fujaba__IterOverridingMethod70ElementsAbstractHandle.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOverridingMethod70ElementsAbstractHandle.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    abstractHandle = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteHandle1.equals (abstractHandle)) ) ;
                                     
                                    // bind overridingMethod71: OverridingMethodAnnotation
                                    fujaba__IterAbstractHandleAnnotationsOverridingMethod71 = abstractHandle.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod71.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod71.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                          overridingMethod71 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between overridingMethod71 and abstractHandle
                                          JavaSDM.ensure ( overridingMethod71.hasInElements ("overridden", abstractHandle) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(overridingMethod70.equals (overridingMethod71)) ) ;
                                           
                                          // bind concreteHandle2: UMLMethod
                                          fujaba__IterOverridingMethod71ElementsConcreteHandle2 = overridingMethod71.iteratorOfElements ("overriding") ;
                                          while ( fujaba__IterOverridingMethod71ElementsConcreteHandle2.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterOverridingMethod71ElementsConcreteHandle2.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(concreteHandle1.equals (concreteHandle2)) && !(abstractHandle.equals (concreteHandle2)) ) ;
                                                 
                                                // bind concreteHandler2: UMLClass
                                                concreteHandler2 = concreteHandle2.getParent () ;
                                                JavaSDM.ensure ( concreteHandler2 != null ) ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(concreteHandler1.equals (concreteHandler2)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   set.add (concreteHandler2);
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod71 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterOverridingMethod71ElementsConcreteHandle2 = overridingMethod71.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod71ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod71ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  {
                     //  for each flow
                     set.add (concreteHandler2);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod70 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterOverridingMethod70ElementsAbstractHandle = overridingMethod70.iteratorOfElements ("overridden") ;
            while ( fujaba__IterOverridingMethod70ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod70ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  // bind overridingMethod72: OverridingMethodAnnotation
                  fujaba__IterAbstractHandleAnnotationsOverridingMethod72 = abstractHandle.iteratorOfAnnotations () ;
                  while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod72.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod72.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod72 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod72 and abstractHandle
                        JavaSDM.ensure ( overridingMethod72.hasInElements ("overridden", abstractHandle) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(overridingMethod70.equals (overridingMethod72)) ) ;
                         
                        // bind concreteHandle2: UMLMethod
                        fujaba__IterOverridingMethod72ElementsConcreteHandle2 = overridingMethod72.iteratorOfElements ("overriding") ;
                        while ( fujaba__IterOverridingMethod72ElementsConcreteHandle2.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOverridingMethod72ElementsConcreteHandle2.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle2)) ) ;
                               
                              // bind concreteHandler2: UMLClass
                              concreteHandler2 = concreteHandle2.getParent () ;
                              JavaSDM.ensure ( concreteHandler2 != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (concreteHandler2);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference56 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterReference56ElementsAbstractHandler = reference56.iteratorOfElements ("references") ;
            while ( fujaba__IterReference56ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference56ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandler);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("OverridingMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
            while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
            {
               try
               {
                  abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation50 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterDelegation50ElementsConcreteHandle2 = delegation50.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation50ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation50ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  {
                     //  for each flow
                     set.add (concreteHandle2);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation51 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle1: UMLMethod
            fujaba__IterDelegation51ElementsConcreteHandle1 = delegation51.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation51ElementsConcreteHandle1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation51ElementsConcreteHandle1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                   
                  // bind overridingMethod73: OverridingMethodAnnotation
                  fujaba__IterConcreteHandle1AnnotationsOverridingMethod73 = concreteHandle1.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandle1AnnotationsOverridingMethod73.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsOverridingMethod73.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod73 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod73 and concreteHandle1
                        JavaSDM.ensure ( overridingMethod73.hasInElements ("overriding", concreteHandle1) ) ;
                         
                        // bind abstractHandle: UMLMethod
                        fujaba__IterOverridingMethod73ElementsAbstractHandle = overridingMethod73.iteratorOfElements ("overridden") ;
                        while ( fujaba__IterOverridingMethod73ElementsAbstractHandle.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOverridingMethod73ElementsAbstractHandle.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              abstractHandle = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandle1.equals (abstractHandle)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (abstractHandle);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization52 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandler1: UMLClass
            fujaba__IterGeneralization52ElementsConcreteHandler1 = generalization52.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization52ElementsConcreteHandler1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization52ElementsConcreteHandler1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteHandler1 = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                   
                  // bind concreteHandle1: UMLMethod
                  fujaba__IterConcreteHandler1MethodsConcreteHandle1 = concreteHandler1.iteratorOfMethods () ;
                  while ( fujaba__IterConcreteHandler1MethodsConcreteHandle1.hasNext () )
                  {
                     try
                     {
                        concreteHandle1 = (UMLMethod) fujaba__IterConcreteHandler1MethodsConcreteHandle1.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                         
                        // bind overridingMethod74: OverridingMethodAnnotation
                        fujaba__IterConcreteHandle1AnnotationsOverridingMethod74 = concreteHandle1.iteratorOfAnnotations () ;
                        while ( fujaba__IterConcreteHandle1AnnotationsOverridingMethod74.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsOverridingMethod74.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod74 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod74 and concreteHandle1
                              JavaSDM.ensure ( overridingMethod74.hasInElements ("overriding", concreteHandle1) ) ;
                               
                              // bind abstractHandle: UMLMethod
                              fujaba__IterOverridingMethod74ElementsAbstractHandle = overridingMethod74.iteratorOfElements ("overridden") ;
                              while ( fujaba__IterOverridingMethod74ElementsAbstractHandle.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOverridingMethod74ElementsAbstractHandle.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    abstractHandle = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteHandle1.equals (abstractHandle)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (abstractHandle);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization67 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterGeneralization67ElementsAbstractHandler = generalization67.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization67ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization67ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        {
                           //  for each flow
                           set.add (abstractHandle);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod74 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterOverridingMethod74ElementsAbstractHandle = overridingMethod74.iteratorOfElements ("overridden") ;
            while ( fujaba__IterOverridingMethod74ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod74ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference56 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterReference56ElementsAbstractHandler = reference56.iteratorOfElements ("references") ;
            while ( fujaba__IterReference56ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference56ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        {
                           //  for each flow
                           set.add (abstractHandle);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("OverridingMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
            while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
            {
               try
               {
                  abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation50 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterDelegation50ElementsConcreteHandle2 = delegation50.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation50ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation50ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  // bind generalization75: GeneralizationAnnotation
                  fujaba__IterConcreteHandler2AnnotationsGeneralization75 = concreteHandler2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandler2AnnotationsGeneralization75.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization75.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization75 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization75 and concreteHandler2
                        JavaSDM.ensure ( generalization75.hasInElements ("subClass", concreteHandler2) ) ;
                         
                        // bind abstractHandler: UMLClass
                        fujaba__IterGeneralization75ElementsAbstractHandler = generalization75.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization75ElementsAbstractHandler.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization75ElementsAbstractHandler.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              abstractHandler = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                               
                              // bind abstractHandle: UMLMethod
                              fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                              while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                              {
                                 try
                                 {
                                    abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (abstractHandle);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation51 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle1: UMLMethod
            fujaba__IterDelegation51ElementsConcreteHandle1 = delegation51.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation51ElementsConcreteHandle1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation51ElementsConcreteHandle1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                   
                  {
                     //  for each flow
                     set.add (concreteHandle1);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization52 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandler1: UMLClass
            fujaba__IterGeneralization52ElementsConcreteHandler1 = generalization52.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization52ElementsConcreteHandler1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization52ElementsConcreteHandler1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteHandler1 = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                   
                  // bind concreteHandle1: UMLMethod
                  fujaba__IterConcreteHandler1MethodsConcreteHandle1 = concreteHandler1.iteratorOfMethods () ;
                  while ( fujaba__IterConcreteHandler1MethodsConcreteHandle1.hasNext () )
                  {
                     try
                     {
                        concreteHandle1 = (UMLMethod) fujaba__IterConcreteHandler1MethodsConcreteHandle1.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                         
                        {
                           //  for each flow
                           set.add (concreteHandle1);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization75 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterGeneralization75ElementsAbstractHandler = generalization75.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization75ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization75ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        {
                           //  for each flow
                           set.add (abstractHandle);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod72 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterOverridingMethod72ElementsConcreteHandle2 = overridingMethod72.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod72ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod72ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  // bind generalization76: GeneralizationAnnotation
                  fujaba__IterConcreteHandler2AnnotationsGeneralization76 = concreteHandler2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandler2AnnotationsGeneralization76.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization76.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization76 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization76 and concreteHandler2
                        JavaSDM.ensure ( generalization76.hasInElements ("subClass", concreteHandler2) ) ;
                         
                        // bind abstractHandler: UMLClass
                        fujaba__IterGeneralization76ElementsAbstractHandler = generalization76.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization76ElementsAbstractHandler.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization76ElementsAbstractHandler.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              abstractHandler = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                               
                              // bind abstractHandle: UMLMethod
                              fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                              while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                              {
                                 try
                                 {
                                    abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteHandle2.equals (abstractHandle)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (abstractHandle);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference56 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterReference56ElementsAbstractHandler = reference56.iteratorOfElements ("references") ;
            while ( fujaba__IterReference56ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference56ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  // bind abstractHandle: UMLMethod
                  fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
                  {
                     try
                     {
                        abstractHandle = (UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                         
                        {
                           //  for each flow
                           set.add (abstractHandle);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Reference") || annotation.equals ("MultiReference") || annotation.equals ("ArrayReference") || annotation.equals ("SingleReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstractHandler);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation50 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterDelegation50ElementsConcreteHandle2 = delegation50.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation50ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation50ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  // bind generalization77: GeneralizationAnnotation
                  fujaba__IterConcreteHandler2AnnotationsGeneralization77 = concreteHandler2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandler2AnnotationsGeneralization77.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization77.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization77 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization77 and concreteHandler2
                        JavaSDM.ensure ( generalization77.hasInElements ("subClass", concreteHandler2) ) ;
                         
                        // bind abstractHandler: UMLClass
                        fujaba__IterGeneralization77ElementsAbstractHandler = generalization77.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization77ElementsAbstractHandler.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization77ElementsAbstractHandler.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              abstractHandler = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (abstractHandler);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof DelegationAnnotation ) ;
             
            // explicit type cast
            delegation51 = (DelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle1: UMLMethod
            fujaba__IterDelegation51ElementsConcreteHandle1 = delegation51.iteratorOfElements ("caller") ;
            while ( fujaba__IterDelegation51ElementsConcreteHandle1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterDelegation51ElementsConcreteHandle1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                   
                  // bind overridingMethod78: OverridingMethodAnnotation
                  fujaba__IterConcreteHandle1AnnotationsOverridingMethod78 = concreteHandle1.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandle1AnnotationsOverridingMethod78.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsOverridingMethod78.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod78 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod78 and concreteHandle1
                        JavaSDM.ensure ( overridingMethod78.hasInElements ("overriding", concreteHandle1) ) ;
                         
                        // bind abstractHandle: UMLMethod
                        fujaba__IterOverridingMethod78ElementsAbstractHandle = overridingMethod78.iteratorOfElements ("overridden") ;
                        while ( fujaba__IterOverridingMethod78ElementsAbstractHandle.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOverridingMethod78ElementsAbstractHandle.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              abstractHandle = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandle1.equals (abstractHandle)) ) ;
                               
                              // bind overridingMethod79: OverridingMethodAnnotation
                              fujaba__IterAbstractHandleAnnotationsOverridingMethod79 = abstractHandle.iteratorOfAnnotations () ;
                              while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod79.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod79.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                    overridingMethod79 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between overridingMethod79 and abstractHandle
                                    JavaSDM.ensure ( overridingMethod79.hasInElements ("overridden", abstractHandle) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(overridingMethod78.equals (overridingMethod79)) ) ;
                                     
                                    // bind concreteHandle2: UMLMethod
                                    fujaba__IterOverridingMethod79ElementsConcreteHandle2 = overridingMethod79.iteratorOfElements ("overriding") ;
                                    while ( fujaba__IterOverridingMethod79ElementsConcreteHandle2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterOverridingMethod79ElementsConcreteHandle2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(concreteHandle1.equals (concreteHandle2)) && !(abstractHandle.equals (concreteHandle2)) ) ;
                                           
                                          // bind concreteHandler2: UMLClass
                                          concreteHandler2 = concreteHandle2.getParent () ;
                                          JavaSDM.ensure ( concreteHandler2 != null ) ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                                           
                                          // bind generalization80: GeneralizationAnnotation
                                          fujaba__IterConcreteHandler2AnnotationsGeneralization80 = concreteHandler2.iteratorOfAnnotations () ;
                                          while ( fujaba__IterConcreteHandler2AnnotationsGeneralization80.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization80.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                generalization80 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between generalization80 and concreteHandler2
                                                JavaSDM.ensure ( generalization80.hasInElements ("subClass", concreteHandler2) ) ;
                                                 
                                                // bind abstractHandler: UMLClass
                                                fujaba__IterGeneralization80ElementsAbstractHandler = generalization80.iteratorOfElements ("superClass") ;
                                                while ( fujaba__IterGeneralization80ElementsAbstractHandler.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterGeneralization80ElementsAbstractHandler.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                      abstractHandler = (UMLClass) fujaba__TmpObject ;
                                                       
                                                      // attribute condition
                                                      JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         set.add (abstractHandler);
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization52 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandler1: UMLClass
            fujaba__IterGeneralization52ElementsConcreteHandler1 = generalization52.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization52ElementsConcreteHandler1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization52ElementsConcreteHandler1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteHandler1 = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                   
                  // bind concreteHandle1: UMLMethod
                  fujaba__IterConcreteHandler1MethodsConcreteHandle1 = concreteHandler1.iteratorOfMethods () ;
                  while ( fujaba__IterConcreteHandler1MethodsConcreteHandle1.hasNext () )
                  {
                     try
                     {
                        concreteHandle1 = (UMLMethod) fujaba__IterConcreteHandler1MethodsConcreteHandle1.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                         
                        // bind overridingMethod81: OverridingMethodAnnotation
                        fujaba__IterConcreteHandle1AnnotationsOverridingMethod81 = concreteHandle1.iteratorOfAnnotations () ;
                        while ( fujaba__IterConcreteHandle1AnnotationsOverridingMethod81.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterConcreteHandle1AnnotationsOverridingMethod81.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod81 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod81 and concreteHandle1
                              JavaSDM.ensure ( overridingMethod81.hasInElements ("overriding", concreteHandle1) ) ;
                               
                              // bind abstractHandle: UMLMethod
                              fujaba__IterOverridingMethod81ElementsAbstractHandle = overridingMethod81.iteratorOfElements ("overridden") ;
                              while ( fujaba__IterOverridingMethod81ElementsAbstractHandle.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOverridingMethod81ElementsAbstractHandle.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    abstractHandle = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteHandle1.equals (abstractHandle)) ) ;
                                     
                                    // bind overridingMethod82: OverridingMethodAnnotation
                                    fujaba__IterAbstractHandleAnnotationsOverridingMethod82 = abstractHandle.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod82.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod82.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                          overridingMethod82 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between overridingMethod82 and abstractHandle
                                          JavaSDM.ensure ( overridingMethod82.hasInElements ("overridden", abstractHandle) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(overridingMethod81.equals (overridingMethod82)) ) ;
                                           
                                          // bind concreteHandle2: UMLMethod
                                          fujaba__IterOverridingMethod82ElementsConcreteHandle2 = overridingMethod82.iteratorOfElements ("overriding") ;
                                          while ( fujaba__IterOverridingMethod82ElementsConcreteHandle2.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterOverridingMethod82ElementsConcreteHandle2.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(concreteHandle1.equals (concreteHandle2)) && !(abstractHandle.equals (concreteHandle2)) ) ;
                                                 
                                                // bind concreteHandler2: UMLClass
                                                concreteHandler2 = concreteHandle2.getParent () ;
                                                JavaSDM.ensure ( concreteHandler2 != null ) ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(concreteHandler1.equals (concreteHandler2)) ) ;
                                                 
                                                // bind generalization83: GeneralizationAnnotation
                                                fujaba__IterConcreteHandler2AnnotationsGeneralization83 = concreteHandler2.iteratorOfAnnotations () ;
                                                while ( fujaba__IterConcreteHandler2AnnotationsGeneralization83.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization83.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                      generalization83 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between generalization83 and concreteHandler2
                                                      JavaSDM.ensure ( generalization83.hasInElements ("subClass", concreteHandler2) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(generalization52.equals (generalization83)) ) ;
                                                       
                                                      // bind abstractHandler: UMLClass
                                                      fujaba__IterGeneralization83ElementsAbstractHandler = generalization83.iteratorOfElements ("superClass") ;
                                                      while ( fujaba__IterGeneralization83ElementsAbstractHandler.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterGeneralization83ElementsAbstractHandler.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                            abstractHandler = (UMLClass) fujaba__TmpObject ;
                                                             
                                                            // attribute condition
                                                            JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(concreteHandler1.equals (abstractHandler)) && !(concreteHandler2.equals (abstractHandler)) ) ;
                                                             
                                                            {
                                                               //  for each flow
                                                               set.add (abstractHandler);
                                                            } //  end for each flow
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization83 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandler: UMLClass
            fujaba__IterGeneralization83ElementsAbstractHandler = generalization83.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization83ElementsAbstractHandler.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization83ElementsAbstractHandler.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  abstractHandler = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandler);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod82 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteHandle2: UMLMethod
            fujaba__IterOverridingMethod82ElementsConcreteHandle2 = overridingMethod82.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod82ElementsConcreteHandle2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod82ElementsConcreteHandle2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                   
                  // bind concreteHandler2: UMLClass
                  concreteHandler2 = concreteHandle2.getParent () ;
                  JavaSDM.ensure ( concreteHandler2 != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                   
                  // bind generalization84: GeneralizationAnnotation
                  fujaba__IterConcreteHandler2AnnotationsGeneralization84 = concreteHandler2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteHandler2AnnotationsGeneralization84.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization84.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization84 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization84 and concreteHandler2
                        JavaSDM.ensure ( generalization84.hasInElements ("subClass", concreteHandler2) ) ;
                         
                        // bind abstractHandler: UMLClass
                        fujaba__IterGeneralization84ElementsAbstractHandler = generalization84.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization84ElementsAbstractHandler.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization84ElementsAbstractHandler.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              abstractHandler = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (abstractHandler);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod81 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterOverridingMethod81ElementsAbstractHandle = overridingMethod81.iteratorOfElements ("overridden") ;
            while ( fujaba__IterOverridingMethod81ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod81ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  // bind overridingMethod85: OverridingMethodAnnotation
                  fujaba__IterAbstractHandleAnnotationsOverridingMethod85 = abstractHandle.iteratorOfAnnotations () ;
                  while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod85.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod85.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod85 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod85 and abstractHandle
                        JavaSDM.ensure ( overridingMethod85.hasInElements ("overridden", abstractHandle) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(overridingMethod81.equals (overridingMethod85)) ) ;
                         
                        // bind concreteHandle2: UMLMethod
                        fujaba__IterOverridingMethod85ElementsConcreteHandle2 = overridingMethod85.iteratorOfElements ("overriding") ;
                        while ( fujaba__IterOverridingMethod85ElementsConcreteHandle2.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOverridingMethod85ElementsConcreteHandle2.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              concreteHandle2 = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle2)) ) ;
                               
                              // bind concreteHandler2: UMLClass
                              concreteHandler2 = concreteHandle2.getParent () ;
                              JavaSDM.ensure ( concreteHandler2 != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                               
                              // bind generalization86: GeneralizationAnnotation
                              fujaba__IterConcreteHandler2AnnotationsGeneralization86 = concreteHandler2.iteratorOfAnnotations () ;
                              while ( fujaba__IterConcreteHandler2AnnotationsGeneralization86.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterConcreteHandler2AnnotationsGeneralization86.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization86 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization86 and concreteHandler2
                                    JavaSDM.ensure ( generalization86.hasInElements ("subClass", concreteHandler2) ) ;
                                     
                                    // bind abstractHandler: UMLClass
                                    fujaba__IterGeneralization86ElementsAbstractHandler = generalization86.iteratorOfElements ("superClass") ;
                                    while ( fujaba__IterGeneralization86ElementsAbstractHandler.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization86ElementsAbstractHandler.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          abstractHandler = (UMLClass) fujaba__TmpObject ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(concreteHandler2.equals (abstractHandler)) ) ;
                                           
                                          {
                                             //  for each flow
                                             set.add (abstractHandler);
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
